#ifndef __DSO__
#define __DSO__

#define	I64						__int64
#define UI64					unsigned __int64

#define CUR_TYPE				DDEX_RAW
//#define CUR_TYPE				DDEX_INT_MV
//#define CUR_TYPE				DDEX_INT_UV
//#define CUR_TYPE				DDEX_DBL_MV
//#define CUR_TYPE				DDEX_DBL_UV
//#define CUR_TYPE				DDEX_I64_MV
//#define CUR_TYPE				DDEX_I64_UV

#define DSTEX_CH2				0x00000001
#define DSTEX_H2L				0x00000004
#define DSTEX_EITHER			0x00000040
#define DSTEX_TOGGLE			0x00000080
#define DSTEX_TYPE				0x000F0000
#define DSTEX_CH				0x00000000
#define DSTEX_EXT				0x00010000
#define DSTEX_SCANLINE			0x000C0000
#define DSTEX_FIELD				0x000D0000
#define DSTEX_ODDFIELD			0x000E0000
#define DSTEX_EVENFIELD			0x000F0000
#define DSTEX_WMMASK			0x00300000
#define DSTEX_WMQUICK			0x00000000
#define DSTEX_WMSLOW			0x00100000
#define DSTEX_WMFOREVER			0x00200000
#define DSTEX_WMCUSTOM			0x00300000

#define SW_CH1_AC				0x00000001
#define SW_CH2_AC				0x00000002
#define SW_CH3_AC				0x00000004
#define SW_CH4_AC				0x00000008
#define SW_CH5_AC				0x00000010
#define SW_CH6_AC				0x00000020
#define SW_CH1_BWL				0x00010000
#define SW_CH2_BWL				0x00020000
#define SW_CH3_BWL				0x00040000
#define SW_CH4_BWL				0x00080000
#define SW_CH5_BWL				0x00100000
#define SW_CH6_BWL				0x00200000
#define SW_CH1_BWL100			0x00400000
#define SW_CH2_BWL100			0x00800000
#define SW_CH3_BWL100			0x01000000
#define SW_CH4_BWL100			0x02000000
#define SW_CH5_BWL100			0x04000000
#define SW_CH6_BWL100			0x08000000
#define SW_ON_MASK				0x0000FF00
#define SW_CH1_ON				0x00000100
#define SW_CH2_ON				0x00000200
#define SW_CH3_ON				0x00000400
#define SW_CH4_ON				0x00000800
#define SW_CH5_ON				0x00001000
#define SW_CH6_ON				0x00002000

#define SW_NOUSED				0x80000000

// Parameter
#define COUP_DC		0
#define COUP_AC		1
#define COUP_GND	2
#define BWL_FULL	0
#define BWL_20M		1
#define BWL_100M	2

#pragma pack(1)
typedef struct _DSTRIGEX
{
	int			iFlag;				// DSTEX_CH1, DSTEX_CH2, DSTEX_H2L, DSTEX_EXT, DST_SCANLINE, DST_TVFIELD, ...
	int			iFlagEx;			// Fill Zero
	I64			i64Sc;				// Sample Clock (unit:Hz)
	I64			i64Thres;			// Threshold (Unit:uV)
	I64			i64Res[12];			// Fill Zero
	I64			i64TrPos;			// Trigger Position (unit: pico-second)
	I64			i64Wait;			// Wait for trigger happen(unit: pico-second), When DSTEX_WAITMODECUSTOM
	int			iBufLen;			// 2000, 4000, 8000, 16000, 32000, 64000, 512000, 1024000, 2048000 ...... 64000000
	int			iSpecial;			// Fill Zero
	int			iCtrlPara;
	int			iScanLine;			// ScanLine
	I64			i64DelayTrig;		// Delay Trigger (Unit: ps)
    int         iRes[6];			// Fill Zero
	I64			*pi64VoltDiv;		// Volt/DIV (Unit:uV)
	I64			*pi64VoltOfs;		// Channel offset (Unit:uV)
} DSTRIGEX, FAR *LPDSTRIGEX;
#pragma pack()

#define DDEX_RAW		0x0000				// Data Type = short ( Raw Data from A/D Converter )
#define DDEX_INT_MV		0x0001				// Data Type = int ( Unit = mV )
#define DDEX_INT_UV		0x0002				// Data Type = int ( Unit = uV )
#define DDEX_DBL_MV		0x0003				// Data Type = double ( Unit = mV )
#define DDEX_DBL_UV		0x0004				// Data Type = double ( Unit = uV )
#define DDEX_I64_MV		0x0005				// Data Type = __int64 ( Unit = mV )
#define DDEX_I64_UV		0x0006				// Data Type = __int64 ( Unit = uV )

typedef struct _DSDATAEX
{
	int		iType;
	int		iFlag;
	int		iTrigOfs;						// in ps
	void	*pvWaveData;
} DSDATAEX, FAR *LPDSDATAEX;

typedef	int (__stdcall *PUDSOINIT)();
typedef	BOOL (__stdcall *PUDSOGETHWINFO)( int iDev, int iItem, LPVOID lpData );
typedef BOOL (__stdcall *PUDSOSTOP)();
typedef	BOOL (__stdcall *PUDSOCAPTURE)( LPDSTRIGEX lpdstrex );
typedef int (__stdcall *PUDSOGETSTATUS)( int iDev );
typedef int (__stdcall *PUDSOGETERRORCODE)();
typedef BOOL (__stdcall *PUDSODATAREADY)();
typedef BOOL (__stdcall *PUDSOREAD)( LPDSDATAEX lpddex );
typedef BOOL (__stdcall *PUDSOFORCETRIG)( int iDev );
typedef BOOL (__stdcall *PUDSOREADWITHFFT)( LPDSDATAEX lpddex, int iChFlag, int iType, int iWindow, double** lpFFT );
typedef BOOL (__stdcall *PUDSOSETTING)( int iItem, int iValue, LPVOID lpvData );
typedef	int (__stdcall *PUDSOSHUTDOWN)();
typedef BOOL (__stdcall *PUDSOINITSTACK)(LPSTR szaID);		
#endif
