#include "Dso.h"

#define DLLIMVOIDPTR	extern "C" VOID*	PASCAL IMPORT
#define DLLIMBOOL		extern "C" BOOL		PASCAL IMPORT
#define DLLIMINT		extern "C" INT		PASCAL IMPORT
#define DLLIMUINTPTR	extern "C" UINT*	PASCAL IMPORT
#define DLLIMDOUBLE		extern "C" DOUBLE	PASCAL IMPORT


// Parameter
#define COUPLING_DC			0
#define COUPLING_AC			1
#define COUPLING_GND		2
#define BWL_FULL			0
#define BWL_20M				1
#define BWL_100M			2
#define REJECT_NONE			0
#define REJECT_HF			1		// High Frequency Reject
#define REJECT_LF			2		// Low Frequency Reject
#define REJECT_NOISE		3
#define WAIT_QUICK			0
#define WAIT_SLOW			1
#define WAIT_FOREVER		2
#define WAIT_CUSTOM			3
//Trigger Source
#define TRIG_SOURCE_CH1		0
#define TRIG_SOURCE_CH2		1
#define TRIG_SOURCE_EXT		2
//Edge Trigger
#define TRIG_EDGE_RISING	0
#define TRIG_EDGE_FALLING	1
#define TRIG_EDGE_EITHER	2
#define TRIG_EDGE_ALTERNATE	3

//Video Trigger
#define TRIG_VIDEO_MODE_SCANLINE		0
#define TRIG_VIDEO_MODE_ANYFIELD		1
#define TRIG_VIDEO_MODE_ODDFIELD		2
#define TRIG_VIDEO_MODE_EVENFIELD		3

//Width Trigger
#define DEFAULT_WIDTH_RANGE	5	//5%
#define TRIG_WIDTH_POLARITY_HIGHPULSE	0
#define TRIG_WIDTH_POLARITY_LOWPULSE	1
#define TRIG_WIDTH_POLARITY_EITHER		2

#define TRIG_WIDTH_CMP_LESS				0
#define TRIG_WIDTH_CMP_GREAT			1
#define TRIG_WIDTH_CMP_EQUAL			2
#define TRIG_WIDTH_CMP_NOT_EQUAL		3

//Runt Trigger
#define TRIG_RUNT_POLARITY_HIGHPULSE	0
#define TRIG_RUNT_POLARITY_LOWPULSE		1
#define TRIG_RUNT_POLARITY_EITHER		2

#define TRIG_RUNT_CMP_LESS				0
#define TRIG_RUNT_CMP_GREAT				1
#define TRIG_RUNT_CMP_EQUAL				2
#define TRIG_RUNT_CMP_NOT_EQUAL			3

//Pattern Trigger
#define TRIG_PATTERN_ANDOR_AND			0
#define TRIG_PATTERN_ANDOR_OR			1

//State Trigger
#define TRIG_STATE_ANDOR_AND			0
#define TRIG_STATE_ANDOR_OR				1

//FFT Type Select
#define FFT_TYPE_LINEAR_RMS		0
#define FFT_TYPE_DBV_RMS		1
#define FFT_TYPE_DBM_RMS		2

//FFT Window Select
#define FFT_WINDOW_RECTANGULAR	0
#define FFT_WINDOW_BLACKMAN		1
#define FFT_WINDOW_HANN			2
#define FFT_WINDOW_HAMMING		3
#define FFT_WINDOW_HARRIS		4
#define FFT_WINDOW_TRIANGULAR	5
#define FFT_WINDOW_COSINE		6
#define FFT_WINDOW_LANCZOS		7
#define FFT_WINDOW_GUASS		8

//Measure Function

#define	MEASURE_FREQ			0
#define	MEASURE_PERIOD			1
#define	MEASURE_VMAX			2
#define	MEASURE_VMIN			3
#define	MEASURE_VHIGH			4
#define	MEASURE_VLOW			5
#define	MEASURE_VPP				6
#define	MEASURE_VAMP			7
#define	MEASURE_RMS				8
#define	MEASURE_VMEAN			9
#define	MEASURE_HIGH_DUTY		10
#define	MEASURE_LOW_DUTY		11
#define	MEASURE_HIGH_PERIOD		12
#define	MEASURE_LOW_PERIOD		13
#define	MEASURE_RISETIME		14
#define	MEASURE_FALLTIME		15
#define	MEASURE_POVERSHOOT		16
#define	MEASURE_NOVERSHOOT		17
#define	MEASURE_VMID			18
#define	MEASURE_CYCLE_RMS		19
#define	MEASURE_CYCLE_MEAN		20

#define	MEASURE_RISE_DELAY		21
#define	MEASURE_FALL_DELAY		22

#define MEASURE_END				-1

typedef struct _MEASUREDATA
{		
	__int64		i64ScData;					//Sample Clock(Unit: Hz)
	int         iRecordLength;
	int			iVoltDiv[2];
	double		dVOfs[2];
	double		dYOfsA[2];
	double		dYOfsB[2];
	double		dYMul[2];					// Volt(mV) = ( Raw Data - dYOfsA ) * dYMul + dYOfsB	
	int			iProbe[2];
	LPWORD		lpwWaveData[2];
}DSMEAS, FAR *LPDSMEAS;


//Initial
typedef	int (__stdcall * PUDSOSDKINIT)();                                                                                 
typedef	int (__stdcall * PUDSOSDKINITSTACK)(char* szSNString);   
typedef	BOOL (__stdcall * PUDSOSDKSELECTGROUP)(int iGROUP);                                                            


//Get Hardware infomation                               
typedef	BOOL (__stdcall * PUDSOSDKGETVENDORNAME)(int iDevice, char* szVendorName);                                        
typedef	BOOL (__stdcall * PUDSOSDKGETPRODUCTNAME)(int iDevice, char* szProductName);                                      
typedef	BOOL (__stdcall * PUDSOSDKGETSERIALNUM)(int iDevice, char* szSerialNum);                                          
typedef	BOOL (__stdcall * PUDSOSDKGETHWVER)(int iDevice, int *piHwVer);                                                   
typedef	BOOL (__stdcall * PUDSOSDKGETFWVER)(int iDevice, int *piFwVer);                                                   
typedef	BOOL (__stdcall * PUDSOSDKGETPRODUCTID)(int iDevice, int *piProductID);                                           
typedef	BOOL (__stdcall * PUDSOSDKGETUSBDEVICEHANDLE)(int iDevice, HANDLE hHandle);                                      
typedef	BOOL (__stdcall * PUDSOSDKGETCALIBRATIONDATA)(int iDevice, double pdbValue[6]);   
typedef	BOOL (__stdcall * PUDSOSDKGETHWINFO)(int iDevice, int iItem, LPVOID lpData);       
typedef	int (__stdcall * PUDSOSDKGETDEVICECOUNT)();


//Capture Setting
typedef	BOOL (__stdcall * PUDSOSDKSETBWL)(int iCh, int iBwlFlag);                                                         
typedef	BOOL (__stdcall * PUDSOSDKSETCOUPLING)(int iCh, int iCouplingFlag);                                               
typedef	BOOL (__stdcall * PUDSOSDKSETCHONOFF)(int iCh, bool bChOn);                                                  
typedef	BOOL (__stdcall * PUDSOSDKSETACQUIREMODE)(int iCh, int iAcquireMode);                                                                                              
typedef	BOOL (__stdcall * PUDSOSDKSETVOLTDIV)(int iCh, int iVoltDiv_uV);                                                  
typedef	BOOL (__stdcall * PUDSOSDKSETVOLTPOS)(int iCh, int iPosition);	//0~16000                                         
typedef	BOOL (__stdcall * PUDSOSDKSETVOLTOFS)(int iCh, int iVoltOfs_uV);                                                  
typedef	BOOL (__stdcall * PUDSOSDKSETSAMPLERATE)(__int64 i64SampleRate);                                                  
typedef	BOOL (__stdcall * PUDSOSDKSETRECORDLENGTH)(int iRecordLength);                                                    
typedef	BOOL (__stdcall * PUDSOSDKSETWAITMODE)(int iWaitMode, __int64 i64CustomWaitTime_ps);                              
typedef	BOOL (__stdcall * PUDSOSDKSETDELAYTIME)(__int64 i64DelayTime_ps);                                                 
typedef	BOOL (__stdcall * PUDSOSDKSETHOLDOFFTIME)(__int64 i64HoldOffTime_ps);                                             
typedef	BOOL (__stdcall * PUDSOSDKSETTRIGPOS)(__int64 i64TrigPosition);                                            
                                                                             
//Trigger Setting
typedef BOOL (__stdcall * PUDSOSDKREADINIFILE)(LPCSTR szFilePath);

typedef	BOOL (__stdcall * PUDSOSDKSETTRIGCOUPLE)(int iTrigCoupleFlag);   
typedef	BOOL (__stdcall * PUDSOSDKSETEDGETRIG)(int iCh, int iSlope, __int64 i64Threshold_uV);                                   
typedef	BOOL (__stdcall * PUDSOSDKSETVIDEOTRIG)(int iCh, int iMode, int iScanline);                                   
typedef	BOOL (__stdcall * PUDSOSDKSETRUNTTRIG)(int iCh, int iPolarity, int iCompareType, int iEqualRange, __int64 i64Width_ps, __int64 i64Threshold1_uV, __int64 i64Threshold2_uV);
typedef	BOOL (__stdcall * PUDSOSDKSETWIDTHTRIG)(int iCh, int iPolarity, int iCompareType, int iEqualRange, __int64 i64Width_ps,  __int64 i64Threshold_uV);
typedef	BOOL (__stdcall * PUDSOSDKSETPATTERNTRIG)(int iSrcA, int iSrcB, int iNotA, int iNotB, int iAndOr, __int64 i64Width_ps, __int64 i64ThresholdA_uV, __int64 i64ThresholdB_uV);
typedef	BOOL (__stdcall * PUDSOSDKSETSTATETRIG)(int iSrcA, int iSrcB, int iNotA, int iNotB, int iAndOr, __int64 i64ThresholdA_uV, __int64 i64ThresholdB_uV);
typedef	BOOL (__stdcall * PUDSOSDKFORCETRIG)();                                                                  
typedef	BOOL (__stdcall * PUDSOSDKCAPTUREEX)();                                                                             
typedef	BOOL (__stdcall * PUDSOSDKSTOP)();	 

//Get Capture status
typedef	int (__stdcall * PUDSOSDKGETSTATUS)(int iDevice);                                                                 
typedef	BOOL (__stdcall * PUDSOSDKDATAREADY)();                                                                           
typedef	int (__stdcall * PUDSOSDKGETERRORCODEEX)();	                  

//Data Read
typedef	BOOL (__stdcall * PUDSOSDKREADEXRAW)(int iDev, int* piFlag, short* lpsData, double pdbYofsA[2], double pdbYofsB[2], double pdbYMul[2], int* piTrigPos);
typedef	BOOL (__stdcall * PUDSOSDKRAWTODBL_MV)(short* lpsSrc, double * lpdbDst, int iLength, double dbYofsA, double dbYofsB, double dbYMul, double dbVOffset_uv, int iProbe);
typedef	BOOL (__stdcall * PUDSOSDKRAWTODBL_UV)(short* lpsSrc, double * lpdbDst, int iLength, double dbYofsA, double dbYofsB, double dbYMul, double dbVOffset_uv, int iProbe);
typedef	BOOL (__stdcall * PUDSOSDKGETFFTDATA)(double* lpdbSrc_mv, int iRecordLength, int iType, int iWindow, double* lpdbFFT);
typedef	BOOL (__stdcall * PUDSOSDKMEASUREMENT)(int* piType, int iStart, int iEnd, LPDSMEAS pDsMeas, bool * pbForceStop, bool * pfResult, double* pdbValue);
        

//FG Setting
typedef	BOOL (__stdcall * PUDSOSDKFGSETTING)(int iDev, LPVOID lpData);                                                    

//Shutdown
typedef	BOOL (__stdcall * PUDSOSDKSHUTDOWN)(); 


//Get Capture Setting
typedef	BOOL (__stdcall * PUDSOSDKGETCHONOFF)(bool bChOn);                                                  
typedef	BOOL (__stdcall * PUDSOSDKGETBWL)(int iCh, int& iBwlFlag);                                                                                                          
typedef	BOOL (__stdcall * PUDSOSDKGETCOUPLING)(int iCh, int& iCouplingFlag);                                                                                                                                                                                                  
typedef	BOOL (__stdcall * PUDSOSDKGETACQUIREMODE)(int iCh, int& iAcquireMode);                                                                                              
typedef	BOOL (__stdcall * PUDSOSDKGETVOLTDIV)(int iCh, int& iVoltDiv_uV);                                                                                                   
typedef	BOOL (__stdcall * PUDSOSDKGETVOLTPOS)(int iCh, int& iPosition);	//0~16000                                                                                          
typedef	BOOL (__stdcall * PUDSOSDKGETVOLTOFS)(int iCh, int& iVoltOfs_uV);                                                                                                   
typedef	BOOL (__stdcall * PUDSOSDKGETSAMPLERATE)(__int64& i64SampleRate);                                                                                                   
typedef	BOOL (__stdcall * PUDSOSDKGETRECORDLENGTH)(int& iRecordLength);                                                                                                     
typedef	BOOL (__stdcall * PUDSOSDKGETWAITMODE)(int iWaitMode, __int64& i64CustomWaitTime_ps);                                                                               
typedef	BOOL (__stdcall * PUDSOSDKGETDELAYTIME)(__int64& i64DelayTime_ps);                                                                                                  
typedef	BOOL (__stdcall * PUDSOSDKGETHOLDOFFTIME)(__int64& i64HoldOffTime_ps);                                                                                              
typedef	BOOL (__stdcall * PUDSOSDKGETTRIGPOS)(__int64& i64TrigPosition);                
typedef	BOOL (__stdcall * PUDSOSDKGETTRIGCOUPLE)(int& iTrigCoupleFlag);  

