// VcDsoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDso.h"
#include "VcDsoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	IDT_CAPTURE				0x100
#define	IDT_REPCAP				0x101
#define GRID_LINE_NUMBER		18

// The function of DsoRun.dll
HMODULE				ghmDso = NULL;


//Initial Function
PUDSOSDKINIT			puDsoSDKInit;			// Initial DSO, it will return how many DSO connect to PC
PUDSOSDKINITSTACK		puDsoSDKInitStack;
PUDSOSDKSELECTGROUP		puDsoSDKSelectGroup;

//Dso Hardware infomation read Function
PUDSOSDKGETHWINFO		puDsoSDKGetHwInfo;		// Get DSO Information
PUDSOSDKGETVENDORNAME	puDsoSDKGetVendorName;
PUDSOSDKGETPRODUCTNAME	puDsoSDKGetProductName;	
PUDSOSDKGETSERIALNUM	puDsoSDKGetSerialNum;	
PUDSOSDKGETHWVER		puDsoSDKGetHwVer;	
PUDSOSDKGETFWVER		puDsoSDKGetFwVer;	
PUDSOSDKGETPRODUCTID	puDsoSDKGetProductID;	
PUDSOSDKGETUSBDEVICEHANDLE	puDsoSDKGetUsbDeviceHandle;
PUDSOSDKGETCALIBRATIONDATA	puDsoSDKGetCalibrationData;
PUDSOSDKGETDEVICECOUNT	puDsoSDKGetDeviceCount;

//Capture Parameter setting
PUDSOSDKSETBWL			puDsoSDKSetBWL;	
PUDSOSDKSETCOUPLING		puDsoSDKSetCoupling;
PUDSOSDKSETCHONOFF		puDsoSDKSetChOnOff;	
PUDSOSDKSETACQUIREMODE	puDsoSDKSetAcquireMode;
PUDSOSDKSETTRIGCOUPLE	puDsoSDKSetTrigCouple;	
PUDSOSDKSETVOLTDIV		puDsoSDKSetVoltDiv;	
PUDSOSDKSETVOLTPOS		puDsoSDKSetVoltPos;	
PUDSOSDKSETVOLTOFS		puDsoSDKSetVoltOfs;	
PUDSOSDKSETSAMPLERATE	puDsoSDKSetSampleRate;	
PUDSOSDKSETRECORDLENGTH	puDsoSDKSetRecordLength;	
PUDSOSDKSETWAITMODE		puDsoSDKSetWaitMode;	
PUDSOSDKSETDELAYTIME	puDsoSDKSetDelayTime;	
PUDSOSDKSETHOLDOFFTIME	puDsoSDKSetHoldoffTime;	
PUDSOSDKSETTRIGPOS		puDsoSDKSetTrigPos;	
PUDSOSDKCAPTUREEX		puDsoSDKCaptureEx;			// Perfrom DSO capture data
PUDSOSDKSTOP			puDsoSDKStop;			// Froce DSO stop capture.
PUDSOSDKFORCETRIG		puDsoSDKForceTrig;	

//Trigger Setting
PUDSOSDKSETEDGETRIG		puDsoSDKSetEdgeTrig;	
PUDSOSDKSETVIDEOTRIG	puDsoSDKSetVideoTrig;	
PUDSOSDKSETRUNTTRIG		puDsoSDKSetRuntTrig;	
PUDSOSDKSETWIDTHTRIG	puDsoSDKSetWidthTrig;	
PUDSOSDKSETPATTERNTRIG	puDsoSDKSetPatternTrig;	
PUDSOSDKSETSTATETRIG	puDsoSDKSetStateTrig;	

//FG setting
PUDSOSDKFGSETTING		puDsoSDKFGSetting;	

//Capture status function
PUDSOSDKGETSTATUS		puDsoSDKGetStatus;		// Return DSO current status.
PUDSOSDKDATAREADY		puDsoSDKDataReady;		// Check whether or not waveform has beed capture.
PUDSOSDKGETERRORCODEEX	puDsoSDKGetErrorCodeEx;	// You may call this function to get error code after DsoCapture or DsoRead return false.	

//DSO data read function and measure function
PUDSOSDKREADEXRAW		puDsoSDKReadExRaw;				// Read waveform data (RAW format) from DSO
PUDSOSDKRAWTODBL_MV		puDsoSDKRawToDbl_mv;
PUDSOSDKRAWTODBL_UV		puDsoSDKRawToDbl_uv;
PUDSOSDKGETFFTDATA		puDsoSDKGetFFTData;

PUDSOSDKMEASUREMENT		puDsoSDKMeasurement;	

//Dso Shutdown function
PUDSOSDKSHUTDOWN		puDsoSDKShutdown;	

//Get Dso Captrue Setting
PUDSOSDKGETCHONOFF		puDsoSDKGetChOnOff;
PUDSOSDKGETBWL			puDsoSDKGetBWL;
PUDSOSDKGETCOUPLING		puDsoSDKGetCoupling;
PUDSOSDKGETACQUIREMODE	puDsoSDKGetAcquireMode;
PUDSOSDKGETTRIGCOUPLE	puDsoSDKGetTrigCouple;
PUDSOSDKGETVOLTDIV		puDsoSDKGetVoltDiv;
PUDSOSDKGETVOLTPOS		puDsoSDKGetVoltPos;
PUDSOSDKGETVOLTOFS		puDsoSDKGetVoltOfs;
PUDSOSDKGETSAMPLERATE	puDsoSDKGetSampleRate;
PUDSOSDKGETRECORDLENGTH	puDsoSDKGetRecordLength;
PUDSOSDKGETWAITMODE		puDsoSDKGetWaitMode;
PUDSOSDKGETDELAYTIME	puDsoSDKGetDelayTime;
PUDSOSDKGETHOLDOFFTIME	puDsoSDKGetHoldoffTime;
PUDSOSDKGETTRIGPOS		puDsoSDKGetTrigPos;



// These are valid sample-rate to set.
// For DS1302, 1202, 1102
__int64		gi64SRTable[] = { 5000000000, 200000000, 100000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 }; 

__int64		gi64SRTable1[] = { 5000000000, 100000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 };


// For DS1002
__int64		gi64SRTableEx[] = { 2500000000, 100000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 }; 

__int64		gi64SRTableEx1[] = { 2500000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 };

// For TS2xxx
__int64		gi64SRTableTs[] = { 25000000000, 10000000000, 5000000000, 2500000000, 1000000000, 500000000, 100000000, 50000000, 
								10000000, 5000000, 1000000, 500000, 100000, 50000, 10000, 5000, 1000, 500, 100 }; 

// These are valid Volt/Div to set.
int			giVoltTable[] = { 10000, 5000, 2000, 1000, 500, 200, 100, 50, 20, 10, 5, 2 };	// Volt(mV)/Div
I64			*gpi64VoltDiv = NULL;				// Pointer to each channel of Volt/Div 
I64			*gpi64VoltOfs = NULL;				// Pointer to each channel of Voltage Offset 
double		*gpdFFTData = NULL;					// Pointer to the FFT information, it will be create at run-time.
BOOL		gfDataReady = false;				// This flag will be set when check DSO status. 
												// true: indicates that the wavefrom has beed captured. false: DSO is Busy


/////////////////////////////////////////////////////////////////////////////
// CVcDsoDlg dialog

CVcDsoDlg::CVcDsoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVcDsoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVcDsoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pWaveData = NULL;
	m_fCaptured = false;
	m_fEquv = false;
	m_ForceTrig = false;
	m_InReCap = false;
	m_fDS1302 = m_fDS1202 = m_fDS1102 = m_fDS1002 = m_fTS2202 = m_fTS2212 = false;
	m_dMul[0] = m_dMul[1] = m_dMul[2] = m_dMul[3] = m_dMul[4] = m_dMul[5] = 1.0f;
	m_dOfsA[0] = m_dOfsA[1] = m_dOfsB[0] = m_dOfsB[1] = 0.0f;
	m_dOfsA[2] = m_dOfsA[3] = m_dOfsB[2] = m_dOfsB[3] = 0.0f;
	m_dOfsA[4] = m_dOfsA[5] = m_dOfsB[4] = m_dOfsB[5] = 0.0f;
}

void CVcDsoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVcDsoDlg)
	DDX_Control(pDX, IDC_CHECK1, m_bnOnCH1);
	DDX_Control(pDX, IDC_CHECK2, m_bnOnCH2);
	DDX_Control(pDX, IDC_CHECK3, m_bnOnCH3);
	DDX_Control(pDX, IDC_CHECK4, m_bnOnCH4);
	DDX_Control(pDX, IDC_CHECK5, m_bnOnCH5);
	DDX_Control(pDX, IDC_CHECK6, m_bnOnCH6);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVcDsoDlg, CDialog)
	//{{AFX_MSG_MAP(CVcDsoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_GETHW, OnGetHW)
	ON_BN_CLICKED(IDC_SETSTACK, &CVcDsoDlg::OnSetStack)
	ON_BN_CLICKED(IDC_CAPTURE, OnCapture)
	ON_BN_CLICKED(IDC_REPCAP, OnRepCap)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_CBN_SELENDOK(IDC_CB_VDCH1, OnSelchangeCbVd)
	ON_CBN_SELENDOK(IDC_CB_VDCH2, OnSelchangeCbVd)
	ON_CBN_SELENDOK(IDC_CB_VDCH3, OnSelchangeCbVd)
	ON_CBN_SELENDOK(IDC_CB_VDCH4, OnSelchangeCbVd)
	ON_BN_CLICKED(IDC_CHK_CH1X10, OnChkProbeCh1)
	ON_BN_CLICKED(IDC_CHK_CH2X10, OnChkProbeCh2)
	ON_BN_CLICKED(IDC_CHK_CH3X10, OnChkProbeCh3)
	ON_BN_CLICKED(IDC_CHK_CH4X10, OnChkProbeCh4)
	ON_BN_CLICKED(IDC_CHK_CH5X10, OnChkProbeCh5)
	ON_BN_CLICKED(IDC_CHK_CH6X10, OnChkProbeCh6)
	ON_CBN_SELENDOK(IDC_CB_SAMPLERATE, OnSelchangeCbSamplerate)
	ON_BN_CLICKED(IDC_FORCETRIG, OnForceTrig)
	ON_CBN_SELENDOK(IDC_CB_DEPTH, OnSelchangeCbDepth)
	ON_BN_CLICKED(IDC_CHECK1,	OnChOnOff)
	ON_BN_CLICKED(IDC_CHECK2,	OnChOnOff)
	ON_BN_CLICKED(IDC_CHECK3,	OnChOnOff)	
	ON_BN_CLICKED(IDC_CHECK4,	OnChOnOff)
	ON_BN_CLICKED(IDC_CHECK5,	OnChOnOff)
	ON_BN_CLICKED(IDC_CHECK6,	OnChOnOff)
	//	
	////}}AFX_MSG_MAP	
	ON_BN_CLICKED(IDC_HWINFO, &CVcDsoDlg::OnBnClickedHwinfo)
	ON_BN_CLICKED(IDC_GETSTATUS, &CVcDsoDlg::OnBnClickedGetstatus)
	ON_BN_CLICKED(IDC_GETMEASURE, &CVcDsoDlg::OnBnClickedGetmeasure)
	ON_BN_CLICKED(IDC_BN_READINI, &CVcDsoDlg::OnBnClickedBnReadini)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcDsoDlg message handlers

void CVcDsoDlg::SampleUIInitial()
{
	int			i;
	CString		str;
	CComboBox	*pCtl;
	CComboBox*	pcbVoltDiv[]=
	{
		(CComboBox *)GetDlgItem( IDC_CB_VDCH1 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH2 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH3 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH4 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH5 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH6 ),
		0
	};
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	pCtl = (CComboBox *)GetDlgItem( IDC_CB_SAMPLERATE );
	for( i = 0 ; i < sizeof(gi64SRTable) / sizeof(gi64SRTable[0]) ; i++ )
	{
		str.Format( "%I64d", gi64SRTable[i] );
		pCtl->AddString( str );
	}
	pCtl->SetCurSel( 8 );					// Select 1MHz Sampling Rate

	// Set the usual memory depths
	pCtlMemDepth = (CComboBox *)GetDlgItem( IDC_CB_DEPTH );
	pCtlMemDepth->AddString( "500" );
	pCtlMemDepth->AddString( "1000" );
	pCtlMemDepth->AddString( "2000" );
	pCtlMemDepth->AddString( "4000" );
	pCtlMemDepth->AddString( "8000" );
	pCtlMemDepth->AddString( "16000" );
	pCtlMemDepth->AddString( "25000" );
	pCtlMemDepth->AddString( "32000" );
	pCtlMemDepth->AddString( "64000" );				
	pCtlMemDepth->AddString( "128000" );
	pCtlMemDepth->AddString( "256000" );
	pCtlMemDepth->AddString( "512000" );			// Just PKDS-1202 or PKDS-1302 can set this depth
	pCtlMemDepth->AddString( "2048000" );			// Just PKDS-1302 can set this depth

	pCtlMemDepth->SetCurSel( 2 );					// Set Memory depth to 2000 points

	pCtl = (CComboBox *)GetDlgItem( IDC_CB_TRIGSRC );
	pCtl->AddString( "CH1" );
	pCtl->AddString( "CH2" );
	pCtl->AddString( "CH1/Scanline" );
	pCtl->AddString( "CH2/Odd Frame" );
	pCtl->AddString( "CH1/Width > 2us" );
	pCtl->AddString( "CH2/Width < 5us" );
	pCtl->AddString( "CH1/P. Runt" );
	pCtl->AddString( "CH2/N. Runt < 2us" );
	pCtl->AddString( "CH1 AND CH2" );
	pCtl->AddString( "!CH2 OR Ext > 2ns" );
	pCtl->AddString( "EXT" );
	pCtl->SetCurSel( 0 );					// CH1


	for( i = 0 ; i < sizeof(giVoltTable) / sizeof(giVoltTable[0]) ; i++ )
	{
		str.Format( "%d", giVoltTable[i] );
		for (int iCh = 0; pcbVoltDiv[iCh] != NULL; iCh ++)
		{
			pcbVoltDiv[iCh]->AddString( str );
		}
	}
	pcbVoltDiv[0]->SetCurSel( 5 );					// Select 2V/Div
	pcbVoltDiv[1]->SetCurSel( 5 );					// Select 2V/Div
	pcbVoltDiv[2]->SetCurSel( 5 );					// Select 2V/Div
	pcbVoltDiv[3]->SetCurSel( 5 );					// Select 2V/Div
	pcbVoltDiv[4]->SetCurSel( 5 );					// Select 2V/Div
	pcbVoltDiv[5]->SetCurSel( 5 );					// Select 2V/Div

	CheckDlgButton( IDC_OP_L2H, BST_CHECKED );
	CheckDlgButton( IDC_RA_NONE, BST_CHECKED );
	CheckDlgButton( IDC_RA_ACQ_MODE0, BST_CHECKED );
	

	SetDlgItemInt( IDC_ED_THRES, 1670000 );   // Set threshold 1.67V
	m_bnOnCH1.SetCheck(BST_CHECKED);
	m_bnOnCH2.SetCheck(BST_CHECKED);
	m_bnOnCH3.SetCheck(BST_CHECKED);
	m_bnOnCH4.SetCheck(BST_CHECKED);
	m_bnOnCH5.SetCheck(BST_CHECKED);
	m_bnOnCH6.SetCheck(BST_CHECKED);

	CheckDlgButton( IDC_CHK_CH1X10, BST_CHECKED );
	OnChkProbeCh1();
	CheckDlgButton( IDC_CHK_CH2X10, BST_CHECKED );
	OnChkProbeCh2();
	CheckDlgButton( IDC_CHK_CH3X10, BST_CHECKED );
	OnChkProbeCh3();
	CheckDlgButton( IDC_CHK_CH4X10, BST_CHECKED );
	OnChkProbeCh4();
	CheckDlgButton( IDC_CHK_CH5X10, BST_CHECKED );
	OnChkProbeCh5();
	CheckDlgButton( IDC_CHK_CH6X10, BST_CHECKED );
	OnChkProbeCh6();

	GetDlgItem( IDC_CAPTURE )->EnableWindow( false );
	GetDlgItem( IDC_REPCAP )->EnableWindow( false );
	GetDlgItem( IDC_STOP )->EnableWindow( false );

	if(CUR_TYPE	== DDEX_RAW)
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);
	this->SetDlgItemText(IDC_EDIT1, "TSA22120413");
	this->SetDlgItemText(IDC_EDIT2, "TSA22120414");
	this->SetDlgItemText(IDC_EDIT3, "TSA22120415");
}

BOOL CVcDsoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Load DSO library
	if( ( ghmDso = LoadLibrary( "DsoSDK.dll" ) ) == NULL )
	{
		GetDlgItem( IDC_GETHW )->EnableWindow( false );
		MessageBox( "Can NOT Load DSOSDK.DLL", NULL, MB_ICONERROR );
		return false;
	}
	else
	{
		//Initial Function
		puDsoSDKInit			= (PUDSOSDKINIT)GetProcAddress( ghmDso, "uDsoSDKInit");
		puDsoSDKInitStack		= (PUDSOSDKINITSTACK)GetProcAddress( ghmDso, "uDsoSDKInitStack");
		puDsoSDKSelectGroup		= (PUDSOSDKSELECTGROUP)GetProcAddress( ghmDso, "uDsoSDKSelectGroup");

		//Dso Hardware infomation read Function
		puDsoSDKGetHwInfo		= (PUDSOSDKGETHWINFO)GetProcAddress( ghmDso, "uDsoSDKGetHwInfo");
		puDsoSDKGetVendorName	= (PUDSOSDKGETVENDORNAME)GetProcAddress( ghmDso, "uDsoSDKGetVendorName");
		puDsoSDKGetProductName	= (PUDSOSDKGETPRODUCTNAME)GetProcAddress( ghmDso, "uDsoSDKGetProductName");
		puDsoSDKGetSerialNum	= (PUDSOSDKGETSERIALNUM)GetProcAddress( ghmDso, "uDsoSDKGetSerialNum");
		puDsoSDKGetHwVer		= (PUDSOSDKGETHWVER)GetProcAddress( ghmDso, "uDsoSDKGetHwVer");
		puDsoSDKGetFwVer		= (PUDSOSDKGETFWVER)GetProcAddress( ghmDso, "uDsoSDKGetFwVer");
		puDsoSDKGetProductID	= (PUDSOSDKGETPRODUCTID)GetProcAddress( ghmDso, "uDsoSDKGetProductID");
		puDsoSDKGetUsbDeviceHandle = (PUDSOSDKGETUSBDEVICEHANDLE)GetProcAddress( ghmDso, "uDsoSDKGetUsbDeviceHandle");
		puDsoSDKGetCalibrationData = (PUDSOSDKGETCALIBRATIONDATA)GetProcAddress( ghmDso, "uDsoSDKGetCalibrationData");
		puDsoSDKGetDeviceCount	= (PUDSOSDKGETDEVICECOUNT)GetProcAddress( ghmDso, "uDsoSDKGetDeviceCount");
		

		//Capture Parameter setting
		puDsoSDKSetBWL			= (PUDSOSDKSETBWL)GetProcAddress( ghmDso, "uDsoSDKSetBWL");
		puDsoSDKSetCoupling		= (PUDSOSDKSETCOUPLING)GetProcAddress( ghmDso, "uDsoSDKSetCoupling");
		puDsoSDKSetChOnOff		= (PUDSOSDKSETCHONOFF)GetProcAddress( ghmDso, "uDsoSDKSetChOnOff");
		puDsoSDKSetAcquireMode	= (PUDSOSDKSETACQUIREMODE)GetProcAddress( ghmDso, "uDsoSDKSetAcquireMode");
		puDsoSDKSetTrigCouple	= (PUDSOSDKSETTRIGCOUPLE)GetProcAddress( ghmDso, "uDsoSDKSetTrigCouple");
		puDsoSDKSetVoltDiv		= (PUDSOSDKSETVOLTDIV)GetProcAddress( ghmDso, "uDsoSDKSetVoltDiv");
		puDsoSDKSetVoltPos		= (PUDSOSDKSETVOLTPOS)GetProcAddress( ghmDso, "uDsoSDKSetVoltPos");
		puDsoSDKSetVoltOfs		= (PUDSOSDKSETVOLTOFS)GetProcAddress( ghmDso, "uDsoSDKSetVoltOfs");
		puDsoSDKSetSampleRate	= (PUDSOSDKSETSAMPLERATE)GetProcAddress( ghmDso, "uDsoSDKSetSampleRate");
		puDsoSDKSetRecordLength = (PUDSOSDKSETRECORDLENGTH)GetProcAddress( ghmDso, "uDsoSDKSetRecordLength");
		puDsoSDKSetWaitMode		= (PUDSOSDKSETWAITMODE)GetProcAddress( ghmDso, "uDsoSDKSetWaitMode");
		puDsoSDKSetDelayTime	= (PUDSOSDKSETDELAYTIME)GetProcAddress( ghmDso, "uDsoSDKSetDelayTime");
		puDsoSDKSetHoldoffTime	= (PUDSOSDKSETHOLDOFFTIME)GetProcAddress( ghmDso, "uDsoSDKSetHoldoffTime");
		puDsoSDKSetTrigPos		= (PUDSOSDKSETTRIGPOS)GetProcAddress( ghmDso, "uDsoSDKSetTrigPos");
		puDsoSDKCaptureEx		= (PUDSOSDKCAPTUREEX)GetProcAddress( ghmDso, "uDsoSDKCaptureEx");
		puDsoSDKStop			= (PUDSOSDKSTOP)GetProcAddress( ghmDso, "uDsoSDKStop");
		puDsoSDKForceTrig		= (PUDSOSDKFORCETRIG)GetProcAddress( ghmDso, "uDsoSDKForceTrig");

		//Trigger setting
		puDsoSDKSetEdgeTrig		= (PUDSOSDKSETEDGETRIG)GetProcAddress( ghmDso, "uDsoSDKSetEdgeTrig");
		puDsoSDKSetVideoTrig	= (PUDSOSDKSETVIDEOTRIG)GetProcAddress( ghmDso, "uDsoSDKSetVideoTrig");
		puDsoSDKSetRuntTrig		= (PUDSOSDKSETRUNTTRIG)GetProcAddress( ghmDso, "uDsoSDKSetRuntTrig");
		puDsoSDKSetWidthTrig	= (PUDSOSDKSETWIDTHTRIG)GetProcAddress( ghmDso, "uDsoSDKSetWidthTrig");
		puDsoSDKSetPatternTrig	= (PUDSOSDKSETPATTERNTRIG)GetProcAddress( ghmDso, "uDsoSDKSetPatternTrig");
		puDsoSDKSetStateTrig	= (PUDSOSDKSETSTATETRIG)GetProcAddress( ghmDso, "uDsoSDKSetStateTrig");

		//FG setting
		puDsoSDKFGSetting		= (PUDSOSDKFGSETTING)GetProcAddress( ghmDso, "uDsoSDKFGSetting");		

		//Capture status function
		puDsoSDKGetStatus		= (PUDSOSDKGETSTATUS)GetProcAddress( ghmDso, "uDsoSDKGetStatus");
		puDsoSDKDataReady		= (PUDSOSDKDATAREADY)GetProcAddress( ghmDso, "uDsoSDKDataReady");
		puDsoSDKGetErrorCodeEx	= (PUDSOSDKGETERRORCODEEX)GetProcAddress( ghmDso, "uDsoSDKGetErrorCodeEx");
		puDsoSDKGetChOnOff		= (PUDSOSDKGETCHONOFF)GetProcAddress( ghmDso, "uDsoSDKGetChOnOff");
				

		////DSO data read function and measure function
		puDsoSDKReadExRaw		= (PUDSOSDKREADEXRAW)GetProcAddress( ghmDso,	"uDsoSDKReadExRaw");

		puDsoSDKRawToDbl_mv		= (PUDSOSDKRAWTODBL_MV)GetProcAddress( ghmDso,	"uDsoSDKRawToDbl_mv");
		puDsoSDKRawToDbl_uv		= (PUDSOSDKRAWTODBL_UV)GetProcAddress( ghmDso,	"uDsoSDKRawToDbl_uv");
		puDsoSDKGetFFTData		= (PUDSOSDKGETFFTDATA)GetProcAddress( ghmDso,	"uDsoSDKGetFFTData");

		puDsoSDKMeasurement		= (PUDSOSDKMEASUREMENT)GetProcAddress( ghmDso, "uDsoSDKMeasurement");		

		//Dso Shutdown function
		puDsoSDKShutdown		= (PUDSOSDKSHUTDOWN)GetProcAddress( ghmDso, "uDsoSDKShutdown");

		//Get Dso Capture Setting
		puDsoSDKGetChOnOff		= (PUDSOSDKGETCHONOFF)GetProcAddress( ghmDso, "uDsoSDKGetChOnOff");
		puDsoSDKGetBWL			= (PUDSOSDKGETBWL)GetProcAddress( ghmDso, "uDsoSDKGetBWL");
		puDsoSDKGetCoupling		= (PUDSOSDKGETCOUPLING)GetProcAddress( ghmDso, "uDsoSDKGetCoupling");
		puDsoSDKGetAcquireMode	= (PUDSOSDKGETACQUIREMODE)GetProcAddress( ghmDso, "uDsoSDKGetAcquireMode");
		puDsoSDKGetTrigCouple	= (PUDSOSDKGETTRIGCOUPLE)GetProcAddress( ghmDso, "uDsoSDKGetTrigCouple");
		puDsoSDKGetVoltDiv		= (PUDSOSDKGETVOLTDIV)GetProcAddress( ghmDso, "uDsoSDKGetVoltDiv");
		puDsoSDKGetVoltPos		= (PUDSOSDKGETVOLTPOS)GetProcAddress( ghmDso, "uDsoSDKGetVoltPos");
		puDsoSDKGetVoltOfs		= (PUDSOSDKGETVOLTOFS)GetProcAddress( ghmDso, "uDsoSDKGetVoltOfs");
		puDsoSDKGetSampleRate	= (PUDSOSDKGETSAMPLERATE)GetProcAddress( ghmDso, "uDsoSDKGetSampleRate");
		puDsoSDKGetRecordLength	= (PUDSOSDKGETRECORDLENGTH)GetProcAddress( ghmDso, "uDsoSDKGetRecordLength");
		puDsoSDKGetWaitMode		= (PUDSOSDKGETWAITMODE)GetProcAddress( ghmDso, "uDsoSDKGetWaitMode");
		puDsoSDKGetDelayTime	= (PUDSOSDKGETDELAYTIME)GetProcAddress( ghmDso, "uDsoSDKGetDelayTime");
		puDsoSDKGetHoldoffTime	= (PUDSOSDKGETHOLDOFFTIME)GetProcAddress( ghmDso, "uDsoSDKGetHoldoffTime");
		puDsoSDKGetTrigPos		= (PUDSOSDKGETTRIGPOS)GetProcAddress( ghmDso, "uDsoSDKGetTrigPos");
	}

	//Initial UI Setting
	SampleUIInitial();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVcDsoDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if( ghmDso )
	{
		puDsoSDKShutdown();		
		FreeLibrary( ghmDso );
	}
	if( m_pWaveData )
		delete [] m_pWaveData;
	if( gpdFFTData )
		delete [] gpdFFTData;
	if( gpi64VoltDiv )
		delete [] gpi64VoltDiv;
	if( gpi64VoltOfs )
		delete [] gpi64VoltOfs;
}

void CVcDsoDlg::OnCancel() 
{
	//CDialog::OnCancel();
}

void CVcDsoDlg::OnClose() 
{
	CDialog::OnOK();
}

void CVcDsoDlg::OnOK() 
{
	CDialog::OnOK();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVcDsoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CVcDsoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC	dc(this); // device context for painting
		CPen		*ppenOrg, penCH1, penCH2, penCH3, penCH4, penCH5, penCH6, penGrid;
		CPen		penFFTCH1;
		CRgn		rgn;
		CRect		rcCanvas;
		int			i, iSel, iSelSR, iTrigSrc;
		int			iSample, iStart;
		CComboBox	*pCtl;

		if( m_fCaptured )
		{
			if( !m_fDS1302 && !m_fTS2212 && m_iBufLen >= 65536 ) // Exception of PKDS-1302
			{
				iSample = 65536 + ( m_iBufLen - 65536 ) * 2;
				iStart = iSample - m_iBufLen;
			}
			else
			{
				iSample = m_iBufLen;
				iStart = 0;
			}
		}
		else
		{
			iSample = 64000;
			iStart = 0;
		}

		dc.SetBkMode( TRANSPARENT );
		// Create Object
		rgn.CreateRectRgn( 0, 0, 1, 1 );
		penCH1.CreatePen( PS_SOLID, 1, RGB( 255, 201, 14 ) );
		penCH2.CreatePen( PS_SOLID, 1, RGB( 0, 255, 255 ) );
		penCH3.CreatePen( PS_SOLID, 1, RGB( 0, 125, 0 ) );
		penCH4.CreatePen( PS_SOLID, 1, RGB( 255, 0, 128 ) );
		penCH5.CreatePen( PS_SOLID, 1, RGB( 0, 0, 255 ) );
		penCH6.CreatePen( PS_SOLID, 1, RGB( 200, 0, 0 ) );
		penFFTCH1.CreatePen( PS_SOLID, 1, RGB( 255, 0, 0 ) );
		penGrid.CreatePen( PS_DOT, 1, RGB( 128, 128, 128 ) );

		// Draw Frame & Set the Clipping Region
		this->GetDlgItem(IDC_ST_PIC)->GetClientRect(rcCanvas);
		this->GetDlgItem(IDC_ST_PIC)->MapWindowPoints(this, rcCanvas);

		dc.Draw3dRect( rcCanvas, RGB( 0, 0, 0 ), RGB( 255, 255, 255 ) );
		ppenOrg = dc.SelectObject( &penGrid );
		dc.MoveTo(rcCanvas.CenterPoint().x, rcCanvas.top);
		dc.LineTo(rcCanvas.CenterPoint().x, rcCanvas.bottom);
		
		for( i = 0 ; i < GRID_LINE_NUMBER ; i ++ )
		{
			dc.MoveTo( rcCanvas.left, rcCanvas.top + (i * rcCanvas.Height() / GRID_LINE_NUMBER) );
			dc.LineTo( rcCanvas.right, rcCanvas.top + (i * rcCanvas.Height() / GRID_LINE_NUMBER) );
		}
		rgn.SetRectRgn( rcCanvas );
		dc.SelectClipRgn( &rgn );

		// Change Mapped Mode
		dc.SetMapMode( MM_ANISOTROPIC );
			
		char	szSR[32];
		I64		i64SR;
		BOOL	fDblCh1, fDblCh2;
		int		iOfsX;

		if( gfDataReady )	// Show when waveform data has beed captured
		{
			pCtl = (CComboBox *)GetDlgItem( IDC_CB_TRIGSRC );
			iTrigSrc = pCtl->GetCurSel();
			pCtl = (CComboBox *)GetDlgItem( IDC_CB_SAMPLERATE );
			iSelSR = pCtl->GetCurSel();
			iOfsX = (int)( 0/*(I64)m_ddex.iTrigOfs / ( 1000000000000i64 / m_i64SampleClock )*/ );

			pCtl->GetLBText( iSelSR, szSR );
			i64SR = _atoi64( szSR );

			// S/R 200MHz mode, DS-1102, 1202, 1302 
			// S/R 100MHz mode, DS-1002					
			// Only 1 Channel active, the buffer data is interlace mode
			// If the trigger by CH1 then the data buffer squence is CH1->CH2->CH1->CH2
			// If the trigger by CH2 then the data buffer squence is CH2->CH1->CH2->CH1
			fDblCh1 = ( iTrigSrc == 0 ) && ( m_iChkOnCH1 == 1 ) &&
					  ( ( ( i64SR == 200000000 ) && ( m_fDS1302 || m_fDS1202 || m_fDS1102 ) ) || ( ( i64SR == 100000000 ) && m_fDS1002 ) );
			fDblCh2 = ( iTrigSrc == 1 ) && ( m_iChkOnCH2 == 1 ) &&
					  ( ( ( i64SR == 200000000 ) && ( m_fDS1302 || m_fDS1202 || m_fDS1102 ) ) || ( ( i64SR == 100000000 ) && m_fDS1002 ) );
			if( fDblCh1 ) 
			{
				// User select trigger by CH1
				pCtl = (CComboBox *)GetDlgItem( IDC_CB_VDCH1 );
				iSel = pCtl->GetCurSel();							
				dc.SetWindowExt( iSample, giVoltTable[iSel] * 8 );			// 8Div * ( CH1 Volt/Div )
				dc.SetViewportExt( 320, 240 );
				dc.SetViewportOrg( 11, 11 );
				dc.SelectObject( &penCH1 );
				dc.MoveTo( iStart + iOfsX, giVoltTable[iSel] * 4 - VFUNC( *m_pCH1, m_dMul[0], m_dOfsA[0], m_dOfsB[0] ) );						
				for( i = 0 ; i < m_iBufLen ; i++ )
				{
					dc.LineTo( iStart + iOfsX + i*2, giVoltTable[iSel] * 4 - VFUNC( *( m_pCH1 + i + m_iBufLen / 4 ), m_dMul[0], m_dOfsA[0], m_dOfsB[0] ) );
					dc.LineTo( iStart + iOfsX + i*2 + 1, giVoltTable[iSel] * 4 - VFUNC( *( m_pCH2 + i + m_iBufLen / 4 ), m_dMul[1], m_dOfsA[1], m_dOfsB[1] ) );
				}
						
			}
			else if( fDblCh2 )
			{
				// User select trigger by CH2
				pCtl = (CComboBox *)GetDlgItem( IDC_CB_VDCH2 );
				iSel = pCtl->GetCurSel();
				dc.SetWindowExt( iSample, giVoltTable[iSel] * 8 );			// 8Div * ( CH1 Volt/Div )
				dc.SetViewportExt( 320, 240 );
				dc.SetViewportOrg( 11, 11 );
				dc.SelectObject( &penCH2 );
				dc.MoveTo( iStart + iOfsX, giVoltTable[iSel] * 6 - VFUNC( *m_pCH2, m_dMul[1], m_dOfsA[1], m_dOfsB[1] ) );
				for( i = 0 ; i < m_iBufLen ; i++ )
				{
					dc.LineTo( iStart + iOfsX + i*2, giVoltTable[iSel] * 6 - VFUNC( *( m_pCH2 + i + m_iBufLen / 4 ), m_dMul[1], m_dOfsA[1], m_dOfsB[1] ) );
					dc.LineTo( iStart + iOfsX + i*2 + 1, giVoltTable[iSel] * 6 - VFUNC( *( m_pCH1 + i + m_iBufLen / 4 ), m_dMul[0], m_dOfsA[0], m_dOfsB[0] ) );
				}
			}
			else		//TravelScope Series
			{
				int iChOnOffVar[] = 
				{
					m_iChkOnCH1,
					m_iChkOnCH2,
					m_iChkOnCH3,
					m_iChkOnCH4,
					m_iChkOnCH5,
					m_iChkOnCH6,
				};
				CComboBox* pcbVoltDiv[]=
				{
					(CComboBox *)GetDlgItem( IDC_CB_VDCH1 ),
					(CComboBox *)GetDlgItem( IDC_CB_VDCH2 ),
					(CComboBox *)GetDlgItem( IDC_CB_VDCH3 ),
					(CComboBox *)GetDlgItem( IDC_CB_VDCH4 ),
					(CComboBox *)GetDlgItem( IDC_CB_VDCH5 ),
					(CComboBox *)GetDlgItem( IDC_CB_VDCH6 ),
					0
				};
				CPen* cChPen[]=
				{
					&penCH1,
					&penCH2,
					&penCH3,
					&penCH4,
					&penCH5,
					&penCH6,
					0
				};
				AQTYPE * pChDataBuf[]=
				{
					m_pCH1, m_pCH2, m_pCH3, m_pCH4, m_pCH5,m_pCH6, 0
				};
				for (int iCh = 0; pcbVoltDiv[iCh] != NULL && iCh < m_iDevCnt * 2; iCh ++)
				{
					if( iChOnOffVar[iCh] == 1 )
					{
						// Set Channel Viewport and Draw Waveform
						iSel = pcbVoltDiv[iCh]->GetCurSel();
						dc.SetWindowExt( iSample, giVoltTable[iSel] * GRID_LINE_NUMBER );		// GRID_LINE_NUMBER * ( CH1 Volt/Div )
						dc.SetViewportExt(rcCanvas.Width(), rcCanvas.Height());
						dc.SetViewportOrg(rcCanvas.left, rcCanvas.top);
						dc.SelectObject( cChPen[iCh] );
						dc.MoveTo( iStart + iOfsX, giVoltTable[iSel] * (4 + 2 * iCh) - VFUNC( *pChDataBuf[iCh], m_dMul[iCh], m_dOfsA[iCh], m_dOfsB[iCh] ) );
						for( i = 0 ; i < m_iBufLen ; i++ )
						{
							int Y = VFUNC( *( pChDataBuf[iCh] + i ), m_dMul[iCh], m_dOfsA[iCh], m_dOfsB[iCh] );
							dc.LineTo( iStart + i + iOfsX, giVoltTable[iSel] * (4 + 2 * iCh) - VFUNC( *( pChDataBuf[iCh] + i ), m_dMul[iCh], m_dOfsA[iCh], m_dOfsB[iCh] ) );
						}
					}
				}
			}
		}
		// =============
		dc.SelectObject( ppenOrg );
		penCH1.DeleteObject();
		penCH2.DeleteObject();
		penCH3.DeleteObject();
		penCH4.DeleteObject();
		penGrid.DeleteObject();

		dc.SetMapMode( MM_TEXT );
		dc.SelectClipRgn( NULL );
		rgn.DeleteObject();

		//CDialog::OnPaint();
	}
}

void CVcDsoDlg::OnGetHW() 
{	
	int				i, iDevCnt;
	int				iBufferIdx = 0;
	CWaitCursor		wait;

	if( iDevCnt = puDsoSDKInit() )
	{
		CString		str, strProduct;
		LPTSTR		psz = strProduct.GetBuffer( 64 );

		m_iDevCnt = iDevCnt;
		gpi64VoltDiv = new I64 [iDevCnt*2];
		gpi64VoltOfs = new I64 [iDevCnt*2];
		str.Format( "%d DSO device(s) were found.",  iDevCnt );
		for( i = 0 ; i < iDevCnt ; i++ )
		{
			puDsoSDKGetProductName( i, psz );
			m_fDS1302 = ( strcmp( psz, "Acute PKDS-1302" ) == 0 );
			m_fDS1202 = ( strcmp( psz, "Acute PKDS-1202" ) == 0 );
			m_fDS1102 = ( strcmp( psz, "Acute PKDS-1102" ) == 0 );
			m_fDS1002 = ( strcmp( psz, "Acute PKDS-1002" ) == 0 );
			m_fTS2202 = ( strcmp( psz, "TS2202A" ) == 0 );
			m_fTS2212 = ( (strcmp( psz, "TS2212A" ) == 0)/* || (strcmp( psz, "TS2212B" ) == 0)*/);
			str.Insert( 999, "\nDevice " );
			str.Insert( 999, (char)i+0x31 );
			str.Insert( 999, ": " );
			str.Insert( 999, psz );
		}
		strProduct.ReleaseBuffer();
		MessageBox( str );
		GetDlgItem( IDC_CAPTURE )->EnableWindow( true );
		GetDlgItem( IDC_REPCAP )->EnableWindow( true );
		GetDlgItem( IDC_STOP )->EnableWindow( true );
		GetDlgItem( IDC_HWINFO )->EnableWindow( true );
		GetDlgItem( IDC_GETSTATUS )->EnableWindow( true );
		GetDlgItem( IDC_GETHW )->EnableWindow( false );
		GetDlgItem( IDC_SETSTACK )->EnableWindow( false );
	}
	else
	{
		MessageBox( "No DSO Hardware found." );
	}

	int	iBufLength = 0;

	if(m_fTS2212)	
		iBufLength = (int)10E6;  // Max 10M points when stack 3 devices
	else
		iBufLength = 2048000;   // 2M points
	
	m_pWaveData = new AQTYPE [iBufLength*2*iDevCnt];							// Prepare the waveform buffer
	if (!m_pWaveData)
	{
		AfxMessageBox("Memory allocate fail");
		this->EndDialog(IDOK);
	}
	ZeroMemory( m_pWaveData, iBufLength * 2 * iDevCnt * sizeof(AQTYPE) );			// Clear waveform buffer
	m_pCH1 = m_pWaveData;												// Set the CH1 of wavefrom pointer
	m_pCH2 = m_pWaveData + iBufLength;									// Set the CH2 of wavefrom pointer
	m_pCH3 = m_pWaveData + iBufLength * 2;								// Set the CH3 of wavefrom pointer
	m_pCH4 = m_pWaveData + iBufLength * 3;								// Set the CH4 of wavefrom pointer
	m_pCH5 = m_pWaveData + iBufLength * 4;								// Set the CH5 of wavefrom pointer
	m_pCH6 = m_pWaveData + iBufLength * 5;								// Set the CH6 of wavefrom pointer
	SetMemDepthItem();  // Set the Memory Depth List
	SetSRItem();
						
}

void CVcDsoDlg::OnSetStack()
{
	int				i, iDevCnt = 0;	
	CWaitCursor		wait;	
	char			szStackList[64]={0};
	//char			szStackList[64]="TSA22120413,TSA22120414,TSA22120415";	//Input format example//
	int				iBufferIdx = 0;
	int				iLength;
	int				iInputEditID[] = 
	{
		IDC_EDIT1,
		IDC_EDIT2,
		IDC_EDIT3,
		0
	};
	for (int i = 0; iInputEditID[i] != 0; i ++)
	{	
		iLength = this->GetDlgItemText(iInputEditID[i], szStackList + iBufferIdx, sizeof(szStackList) - iBufferIdx);
		if (iLength > 0)
		{
			szStackList[iBufferIdx + iLength] = ',';
			szStackList[iBufferIdx + iLength + 1] = 0;
			iBufferIdx += iLength + 1;
			iDevCnt++;
		}
	}


	if( puDsoSDKInitStack((LPSTR)szStackList))
	{
		CString		str, strProduct;
		LPTSTR		psz = strProduct.GetBuffer( 64 );
			
		m_iDevCnt = iDevCnt;
		gpi64VoltDiv = new I64 [iDevCnt*2];
		gpi64VoltOfs = new I64 [iDevCnt*2];
		str.Format( "%d DSO device(s) were found.",  iDevCnt );
		for( i = 0 ; i < iDevCnt ; i++ )
		{
			puDsoSDKGetProductName( i, psz );
			m_fDS1302 = ( strcmp( psz, "Acute PKDS-1302" ) == 0 );
			m_fDS1202 = ( strcmp( psz, "Acute PKDS-1202" ) == 0 );
			m_fDS1102 = ( strcmp( psz, "Acute PKDS-1102" ) == 0 );
			m_fDS1002 = ( strcmp( psz, "Acute PKDS-1002" ) == 0 );
			m_fTS2202 = ( strcmp( psz, "TS2202A" ) == 0 );
			m_fTS2212 = ( strcmp( psz, "TS2212A" ) == 0 );
			str.Insert( 999, "\nDevice " );
			str.Insert( 999, (char)i+0x31 );
			str.Insert( 999, ": " );
			str.Insert( 999, psz );
		}
		strProduct.ReleaseBuffer();
		MessageBox( str );
		GetDlgItem( IDC_CAPTURE )->EnableWindow( true );
		GetDlgItem( IDC_REPCAP )->EnableWindow( true );
		GetDlgItem( IDC_STOP )->EnableWindow( true );
		GetDlgItem( IDC_HWINFO )->EnableWindow( true );
		GetDlgItem( IDC_GETSTATUS )->EnableWindow( true );
		GetDlgItem( IDC_GETHW )->EnableWindow( false );
		GetDlgItem( IDC_SETSTACK )->EnableWindow( false );
	}
	else
	{
		MessageBox( "No DSO Hardware found." );
	}

	int	iBufLength = 0;

	if(m_fTS2212)
		iBufLength = (int)10E6;  // Max 10M points when stack 3 device//
	else
		iBufLength = 2048000;   // 2M points
	if (m_pWaveData)
		delete m_pWaveData;
	m_pWaveData = new AQTYPE [iBufLength*2*iDevCnt];							// Prepare the waveform buffer
	if (!m_pWaveData)
	{
		AfxMessageBox("Memory allocate fail");
		this->EndDialog(IDOK);
	}
	ZeroMemory( m_pWaveData, iBufLength * 2 * iDevCnt * sizeof(AQTYPE) );			// Clear waveform buffer
	m_pCH1 = m_pWaveData;												// Set the CH1 of wavefrom pointer
	m_pCH2 = m_pWaveData + iBufLength;									// Set the CH2 of wavefrom pointer
	m_pCH3 = m_pWaveData + iBufLength * 2;								// Set the CH3 of wavefrom pointer
	m_pCH4 = m_pWaveData + iBufLength * 3;								// Set the CH4 of wavefrom pointer
	m_pCH5 = m_pWaveData + iBufLength * 4;								// Set the CH5 of wavefrom pointer
	m_pCH6 = m_pWaveData + iBufLength * 5;								// Set the CH6 of wavefrom pointer

	SetMemDepthItem();  // Set the Memory Depth List
	SetSRItem();
}

void CVcDsoDlg::Freq2Str( __int64 i64Freq, CString &str )
{
	if( i64Freq / 1000i64 > 0 )
	{
		i64Freq /= 1000i64;
		if( i64Freq / 1000i64 > 0 )
		{
			i64Freq /= 1000i64;
			if( i64Freq / 1000i64 > 0 )
			{
				i64Freq /= 1000i64;
				str.Format( "%I64d GHz", i64Freq );
			}
			else
			{
				str.Format( "%I64d MHz", i64Freq );
			}
		}
		else
		{
			str.Format( "%I64d KHz", i64Freq );
		}
	}
	else
	{
		str.Format( "%I64d Hz", i64Freq );
	}
}

void CVcDsoDlg::SetSRItem()
{
	int			i, iSel;
	CString		str;
	CComboBox	*pCtl;
	CString		strSR;
	bool		fFound = false;
	
	m_iChkOnCH1 = m_bnOnCH1.GetCheck();
	m_iChkOnCH2 = m_bnOnCH2.GetCheck();
	m_iChkOnCH3 = m_bnOnCH3.GetCheck();
	m_iChkOnCH4 = m_bnOnCH4.GetCheck();
	m_iChkOnCH5 = m_bnOnCH5.GetCheck();
	m_iChkOnCH6 = m_bnOnCH6.GetCheck();

	pCtl = (CComboBox *)GetDlgItem( IDC_CB_SAMPLERATE );
	pCtl->GetWindowText( strSR );
	iSel = pCtl->GetCurSel();
	pCtl->ResetContent();

	if( m_fDS1002 )
	{
		if( ( ( m_iChkOnCH1 + m_iChkOnCH2 ) & 0x01 ) || ( m_iChkOnCH1 + m_iChkOnCH2 == 0 ) )
			for( i = 0 ; i < sizeof(gi64SRTableEx) / sizeof(gi64SRTableEx[0]) ; i++ )
			{
				Freq2Str( gi64SRTableEx[i], str );
				str.Format( "%I64d", gi64SRTableEx[i] );
				pCtl->AddString( str );
			}
		else
			for( i = 0 ; i < sizeof(gi64SRTableEx1) / sizeof(gi64SRTableEx1[0]) ; i++ )
			{
				str.Format( "%I64d", gi64SRTableEx1[i] );
				pCtl->AddString( str );
			}

	}
	else if( m_fDS1102 || m_fDS1202 || m_fDS1302 )
	{
		if( ( ( m_iChkOnCH1 + m_iChkOnCH2 ) & 0x01 ) || ( m_iChkOnCH1 + m_iChkOnCH2 == 0 ) )
			for( i = 0 ; i < sizeof(gi64SRTable) / sizeof(gi64SRTable[0]) ; i++ )
			{
				str.Format( "%I64d", gi64SRTable[i] );
				pCtl->AddString( str );
			}
		else
			for( i = 0 ; i < sizeof(gi64SRTable1) / sizeof(gi64SRTable1[0]) ; i++ )
			{
				str.Format( "%I64d", gi64SRTable1[i] );
				pCtl->AddString( str );
			}

	}
	else
	{
		for( i = 0 ; i < sizeof(gi64SRTableTs) / sizeof(gi64SRTableTs[0]) ; i++ )
		{
			str.Format( "%I64d", gi64SRTableTs[i] );
			pCtl->AddString( str );
		}
	}

	for( i = 0; i < pCtl->GetCount(); i++ )
	{
		pCtl->GetLBText( i, str );
		if( strcmp( strSR, str ) == 0 )
		{
			iSel = i;
			fFound = true;
			break;
		}
	}	

	pCtl->SetCurSel(iSel);

}

void CVcDsoDlg::SetMemDepthItem()
{
	pCtlMemDepth->ResetContent();

	if( m_fTS2212 ) // TS2212A Max Memory Depth = 64M
	{
		pCtlMemDepth->AddString( "10000" );
		pCtlMemDepth->AddString( "50000" );
		pCtlMemDepth->AddString( "100000" );
		pCtlMemDepth->AddString( "500000" );
		pCtlMemDepth->AddString( "1000000" );
		pCtlMemDepth->AddString( "5000000" );
		pCtlMemDepth->AddString( "10000000" );
		pCtlMemDepth->AddString( "32000000" );
		pCtlMemDepth->AddString( "64000000" );				
	}
	else if( m_fTS2202 ) // TS2202A Max Memory Depth = 10K
	{
		pCtlMemDepth->AddString( "500" );
		pCtlMemDepth->AddString( "1000" );
		pCtlMemDepth->AddString( "2000" );
		pCtlMemDepth->AddString( "4000" );
		pCtlMemDepth->AddString( "8000" );
		pCtlMemDepth->AddString( "10000" );
	}
	else if( m_fDS1302 )  // DS1302 Max Memory Depth = 2M
	{
		pCtlMemDepth->AddString( "500" );
		pCtlMemDepth->AddString( "1000" );
		pCtlMemDepth->AddString( "2000" );
		pCtlMemDepth->AddString( "4000" );
		pCtlMemDepth->AddString( "8000" );
		pCtlMemDepth->AddString( "16000" );
		pCtlMemDepth->AddString( "25000" );
		pCtlMemDepth->AddString( "32000" );
		pCtlMemDepth->AddString( "64000" );				
		pCtlMemDepth->AddString( "128000" );
		pCtlMemDepth->AddString( "256000" );
		pCtlMemDepth->AddString( "512000" );			
		pCtlMemDepth->AddString( "2048000" );
	}
	else if( m_fDS1202 )  // DS1202 Max Memory Depth = 512K
	{
		pCtlMemDepth->AddString( "500" );
		pCtlMemDepth->AddString( "1000" );
		pCtlMemDepth->AddString( "2000" );
		pCtlMemDepth->AddString( "4000" );
		pCtlMemDepth->AddString( "8000" );
		pCtlMemDepth->AddString( "16000" );
		pCtlMemDepth->AddString( "25000" );
		pCtlMemDepth->AddString( "32000" );
		pCtlMemDepth->AddString( "64000" );				
		pCtlMemDepth->AddString( "128000" );
		pCtlMemDepth->AddString( "256000" );
		pCtlMemDepth->AddString( "512000" );
	}
	else // if( m_fDS1102 || m_fDS1002 )  // DS1102, DS1002 Max Memory Depth = 64K
	{
		pCtlMemDepth->AddString( "500" );
		pCtlMemDepth->AddString( "1000" );
		pCtlMemDepth->AddString( "2000" );
		pCtlMemDepth->AddString( "4000" );
		pCtlMemDepth->AddString( "8000" );
		pCtlMemDepth->AddString( "16000" );
		pCtlMemDepth->AddString( "25000" );
		pCtlMemDepth->AddString( "32000" );
		pCtlMemDepth->AddString( "64000" );	
	}
	

	CString			strSampleRate;
	
	GetDlgItemText( IDC_CB_SAMPLERATE, strSampleRate );
	pCtlMemDepth = (CComboBox *)GetDlgItem( IDC_CB_DEPTH );

	if( !m_fTS2202 && !m_fTS2212 )
	{   // Only DS1K used 
		if( strSampleRate.Compare( "2500000000" ) == 0 || strSampleRate.Compare( "5000000000" ) == 0 ) // 2.5G & 5G, Capture mode: Equivalent
		{
			pCtlMemDepth->ResetContent();
			pCtlMemDepth->AddString( "500" );
			pCtlMemDepth->AddString( "1000" );
			pCtlMemDepth->AddString( "2000" );
			pCtlMemDepth->AddString( "4000" );
			pCtlMemDepth->AddString( "8000" );
			pCtlMemDepth->AddString( "16000" );
			pCtlMemDepth->AddString( "25000" ); // Max. memory depth 25K on Equivalent mode
		}
	}

	if( m_fTS2212 )
		pCtlMemDepth->SetCurSel( 0 );
	else if( m_fTS2202 )
		pCtlMemDepth->SetCurSel( 5 );
	else
		pCtlMemDepth->SetCurSel( 2 );
}

void CVcDsoDlg::SetAllPara()
{
	int			iSel, iCh;
	__int64		i64Threshold;
	CComboBox	*pctl;
	CComboBox*	pcbVoltDiv[] =
	{
		(CComboBox *)GetDlgItem( IDC_CB_VDCH1 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH2 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH3 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH4 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH5 ),
		(CComboBox *)GetDlgItem( IDC_CB_VDCH6 ),
		0
	};
	char		szSR[32];


	pctl = (CComboBox *)GetDlgItem( IDC_CB_SAMPLERATE );
	iSel = pctl->GetCurSel();
	pctl->GetLBText( iSel, szSR );
	I64 i64SampleClock = _atoi64( szSR );

	if( iSel == 0 )
		m_fEquv = true;  // Equivalent mode
	else
		m_fEquv = false;

	puDsoSDKSetSampleRate(i64SampleClock);	
	puDsoSDKSetTrigPos(0);			
	
	for (int iCh = 0; pcbVoltDiv[iCh] != NULL && iCh < m_iDevCnt*2; iCh++)
	{
		iSel = pcbVoltDiv[iCh]->GetCurSel();
		puDsoSDKSetVoltDiv(iCh, (__int64)giVoltTable[iSel] * 1000i64);	// mV -> uV
		puDsoSDKSetVoltOfs(iCh, 0);
	}

	pctl = (CComboBox *)GetDlgItem( IDC_CB_DEPTH );	
	if (GetDlgItemInt( IDC_CB_DEPTH ) > (int)5E6)
	{
		AfxMessageBox("Record Length is limited to 5M in this sample");
		pctl->SetCurSel(5);
	}		
	m_iBufLen = GetDlgItemInt( IDC_CB_DEPTH );
	puDsoSDKSetRecordLength(m_iBufLen);

	m_pCH2 = m_pCH1 + m_iBufLen;
	m_pCH3 = m_pCH2 + m_iBufLen;		
	m_pCH4 = m_pCH3 + m_iBufLen;		
	m_pCH5 = m_pCH4 + m_iBufLen;		
	m_pCH6 = m_pCH5 + m_iBufLen;		

	pctl = (CComboBox *)GetDlgItem( IDC_CB_TRIGSRC );
	iSel = pctl->GetCurSel();
	iCh = iSel % 2;
	if( ( iSel == 0 && IsDlgButtonChecked( IDC_CHK_CH1X10 ) ) || ( iSel == 1 && IsDlgButtonChecked( IDC_CHK_CH2X10 ) ) )
		i64Threshold = GetDlgItemInt( IDC_ED_THRES ) / 10;
	else
		i64Threshold = GetDlgItemInt( IDC_ED_THRES ) / 1;
	
	switch( iSel )
	{
		//Edge Trigger//
		case 0:
		case 1: 
			puDsoSDKSetEdgeTrig(iCh, IsDlgButtonChecked( IDC_OP_H2L ), i64Threshold);
			break;

		//Video Trigger//
		case 2:	
			puDsoSDKSetVideoTrig(iCh, TRIG_VIDEO_MODE_SCANLINE, 1);	//Trigger on first scanline
			break;
		case 3:
			puDsoSDKSetVideoTrig(iCh, TRIG_VIDEO_MODE_ODDFIELD, 0);	//Trigger on odd field
			break;

		//Width Trigger//
		//puDsoSDKSetWidthTrig(int iCh, int iPolarity, int iCompareType, int iEqualRange, __int64 i64Width_ps,  __int64 i64Threshold_uV);
		case 4:
			//Trigger on High Pulse > 2 us
			puDsoSDKSetWidthTrig(iCh, TRIG_WIDTH_POLARITY_HIGHPULSE, TRIG_WIDTH_CMP_GREAT, DEFAULT_WIDTH_RANGE, (__int64)2E6, i64Threshold);	
			break;
		case 5:
			//Trigger on Low Pulse < 5 us
			puDsoSDKSetWidthTrig(iCh, TRIG_WIDTH_POLARITY_LOWPULSE, TRIG_WIDTH_CMP_LESS, DEFAULT_WIDTH_RANGE, (__int64)5E6, i64Threshold);		
			break;
		
		//Runt Trigger//
		//puDsoSDKSetRuntTrig(int iCh, int iPolarity, int iCompareType, int iEqualRange, __int64 i64Width_ps, __int64 i64Threshold1_uV, __int64 i64Threshold2_uV);
		case 6:
			//Trigger on High Runt, Threshold A = Threshold * 0.9, Threshold B = Threshold * 1.1//
			puDsoSDKSetRuntTrig(iCh, TRIG_RUNT_POLARITY_HIGHPULSE, TRIG_RUNT_CMP_GREAT, 0, 0, (__int64)(i64Threshold * 0.9), (__int64)(i64Threshold * 1.1));	
			break;
		case 7:
			//Trigger on Low Runt < 2 us, Threshold A = Threshold * 0.9, Threshold B = Threshold * 1.1//
			puDsoSDKSetRuntTrig(iCh, TRIG_RUNT_POLARITY_LOWPULSE, TRIG_RUNT_CMP_LESS, DEFAULT_WIDTH_RANGE, (__int64)2E6, (__int64)(i64Threshold * 0.9), (__int64)(i64Threshold * 1.1));	
			break;

		//Pattern Trigger//
		//puDsoSDKSetPatternTrig(int iSrcA, int iSrcB, int iNotA, int iNotB, int iAndOr, __int64 i64Width_ps, __int64 i64ThresholdA_uV, __int64 i64ThresholdB_uV);
		case 8:
			//Trigger on CH1 AND CH2 = True//
			puDsoSDKSetPatternTrig(TRIG_SOURCE_CH1, TRIG_SOURCE_CH2, 0, 0, TRIG_PATTERN_ANDOR_AND, 0, i64Threshold, i64Threshold);					
			break;
		case 9:
			//Trigger on !CH2 OR EXT = True, Width > 2 ns//
			puDsoSDKSetPatternTrig(TRIG_SOURCE_CH2, TRIG_SOURCE_EXT, 1, 0, TRIG_PATTERN_ANDOR_OR, (__int64) 2E3, i64Threshold, i64Threshold);							
			break;

		//Ext Trigger//
		case 10:
			if (IsDlgButtonChecked( IDC_OP_H2L ))
				puDsoSDKSetEdgeTrig(TRIG_SOURCE_EXT, TRIG_EDGE_FALLING, 0);
			else
				puDsoSDKSetEdgeTrig(TRIG_SOURCE_EXT, TRIG_EDGE_RISING, 0);
			break;
	}
	

	//Set Trigger coupling setting
	int iTrigRejectFlag = this->GetCheckedRadioButton(IDC_RA_NONE, IDC_RA_NOISEREJECT) - IDC_RA_NONE;
	puDsoSDKSetTrigCouple(iTrigRejectFlag);


	//Set Bandwidth limit / AC coupling / Channel display for all channel//
	bool bChDisplay[] = 
	{
		m_bnOnCH1.GetCheck() == BST_CHECKED,
		m_bnOnCH2.GetCheck() == BST_CHECKED,
		m_bnOnCH3.GetCheck() == BST_CHECKED,
		m_bnOnCH4.GetCheck() == BST_CHECKED,
		m_bnOnCH5.GetCheck() == BST_CHECKED,
		m_bnOnCH6.GetCheck() == BST_CHECKED,
	};
	bool bACCoupling[] = 
	{
		!!IsDlgButtonChecked( IDC_CHK_AC1 ),
		!!IsDlgButtonChecked( IDC_CHK_AC2 ),
		!!IsDlgButtonChecked( IDC_CHK_AC3 ),
		!!IsDlgButtonChecked( IDC_CHK_AC4 ),
		!!IsDlgButtonChecked( IDC_CHK_AC5 ),
		!!IsDlgButtonChecked( IDC_CHK_AC6 ),
	};
	int iBWL[]=	
	{
		(!!IsDlgButtonChecked( IDC_CHK_BW1 )) ? BWL_20M : BWL_FULL,
		(!!IsDlgButtonChecked( IDC_CHK_BW2 )) ? BWL_20M : BWL_FULL,
		(!!IsDlgButtonChecked( IDC_CHK_BW3 )) ? BWL_20M : BWL_FULL,
		(!!IsDlgButtonChecked( IDC_CHK_BW4 )) ? BWL_20M : BWL_FULL,
		(!!IsDlgButtonChecked( IDC_CHK_BW5 )) ? BWL_20M : BWL_FULL,
		(!!IsDlgButtonChecked( IDC_CHK_BW6 )) ? BWL_20M : BWL_FULL,
		
	};
	int iAcquireMode = this->GetCheckedRadioButton(IDC_RA_ACQ_MODE0, IDC_RA_ACQ_MODE5) - IDC_RA_ACQ_MODE0;
	for (int iCh = 0; iCh < m_iDevCnt*2; iCh++)
	{
		puDsoSDKSetCoupling(iCh, bACCoupling[iCh]);
		puDsoSDKSetBWL(iCh, iBWL[iCh]);
		puDsoSDKSetChOnOff(iCh, bChDisplay[iCh]);

		puDsoSDKSetAcquireMode(iCh, iAcquireMode);
	}
}

void CVcDsoDlg::GetErrStr( int iErrCode, LPSTR lpszErrMsg, int iSize )
{	
	const char* szErrorMsg[]=
	{
		"NO ERROR"
		"DSO_ERROR_BADPOINTER",
		"DSO_UNDEFINED_PARAMETER",
		"DSO_CHANNELINDEX_OUT_RANGE",
		"DSO_DEVICEINDEX_OUT_RANGE",
		"DSO_UNSUPPORT_VOLTDIV",
		"DSO_VOLTPOS_OUT_RANGE",
		"DSO_TRIGPOS_OUT_RANGE",
		"DSO_TREASHOLD_OUT_RANGE",
		"DSO_WAIT_TIME_OUT_RANGE",
		"DSO_TRIGGER_NOT_SUPPORT",
		"DSO_VIDEO_TRIG_ERROR",
		"DSO_TRIG_WAIT_ERROR",
		"DSO_RECORD_LENGTH_ERROR",
		"DSO_NO_HARDWARE",
		"DSO_UNKNOWN_ERROR",
		"DSO_SAMPLE_RATE_ERROR",
		"DSO_MEMORY_NOT_ENOUGH",
		"DSO_MEASURE_TYPE_ERROR",
		"DSO_MEASURE_RANGE_ERROR",
		"DSO_MEASURE_DATA_ERROR",
		"DSO_GROUP_INDEX_OUT_RANGE",

		"DSO_MAIN_DLL_NOT_FOUND",
		"DSO_MAIN_DLL_FUNCTION_ERR",
		"DSO_MAIN_DLL_LOAD_ERR",
		"DSO_GET_TEMP_NAME_ERR",
		"DSO_GET_TEMP_DIR_ERR",
		"DSO_FILE_COPY_ERR",
		"DSO_NOT_INITIAL",
		"DSO_GROUP_PARAMETER_ERR",		
		0
	};
	strcpy_s(lpszErrMsg, iSize, szErrorMsg[iErrCode]);
}




#define ARRAY_MODE

void CVcDsoDlg::SetFGPara()
{
	//FG SDK Block Start
//"FGSDK_Symbol.h" contains the struct and const value declarations.

#ifdef ARRAY_MODE
	double sCh1Data[] = 
	{
		FGSDK_DATA_CH1 | FGSDK_ARRAY_MODE,
		FGSDK_SINE,			//Wave function
		1500,				//Frequency
		20,					//Phase
		0,					//Duty cycle
		0,					//Leading time (us)
		0,					//Trailing time (us)
		2.5,				//Voltage amplitude
		1.25,				//Voltage offset
	};
	double sCh2Data[] =
	{
		FGSDK_DATA_CH2 | FGSDK_ARRAY_MODE,
		FGSDK_PULSE,		//Wave function
		1000,				//Frequency
		0,					//Phase
		35,					//Duty cycle
		100,				//Leading time (us)
		200,				//Trailing time (us)
		2.0,				//Voltage amplitude
		1.0,				//Voltage offset
	};

	double sCh1ModulData[]=
	{
		FGSDK_MODUL_MODE_CH1 | FGSDK_ARRAY_MODE,
		FGSDK_SINE, 			//Wave function
		100,					//Frequency
		0,						//Phase
		0,						//Duty cycle
		0,						//Leading time(us)
		0,						//Trailing time(us)
		FGSDK_MODUL_AM,			//Modulation type
		100, 					//Modulation scale
	};
	double sTrigParameter[] =
	{
		FGSDK_TRIG_DATA | FGSDK_ARRAY_MODE,
		FGSDK_TRIG_TYPE_INT,	//Trigger source
		FGSDK_EDGE_RISING,		//Trigger edge
		100,					//Internal Trigger source frequency
	};
	double dbCh2CW = FGSDK_CW_MODE_CH2;
	double dbSendPtn = FGSDK_SENDPTN;
	int iDevice = 0;
	puDsoSDKFGSetting(iDevice, &sCh1Data); //Set Ch1 carrier parameters
	puDsoSDKFGSetting(iDevice, &sCh2Data); //Set Ch2 carrier parameters
	puDsoSDKFGSetting(iDevice, &sCh1ModulData); //Set Ch1 to Modulation mode
	puDsoSDKFGSetting(iDevice, &dbCh2CW);//Set Ch2 to Continuous wave mode
	puDsoSDKFGSetting(iDevice, &sTrigParameter);//Set Trigger data
	puDsoSDKFGSetting(iDevice, &dbSendPtn);		//Send FG pattern
#else	  
	CarrierParameter sCh1Data = 
	{
		FGSDK_DATA_CH1,
		FGSDK_SINE,			//Wave function
		1500,				//Frequency
		20,					//Phase
		0,					//Duty cycle
		0,					//Leading time (us)
		0,					//Trailing time (us)
		2.5,				//Voltage amplitude
		1.25,				//Voltage offset
	};
	CarrierParameter sCh2Data =
	{
		FGSDK_DATA_CH2,
		FGSDK_PULSE,		//Wave function
		1000,				//Frequency
		0,					//Phase
		35,					//Duty cycle
		100,				//Leading time (us)
		200,				//Trailing time (us)
		2.0,				//Voltage amplitude
		1.0,				//Voltage offset
	};

	ModulationParameter sCh1ModulData =
	{
		FGSDK_MODUL_MODE_CH1,
		FGSDK_SINE, 			//Wave function
		100,					//Frequency
		0,						//Phase
		0,						//Duty cycle
		0,						//Leading time(us)
		0,						//Trailing time(us)
		FGSDK_MODUL_AM,			//Modulation type
		100, 					//Modulation scale
	};
	TriggerParameter sTrigParameter =
	{
		FGSDK_TRIG_DATA,
		FGSDK_TRIG_TYPE_INT,	//Trigger source
		FGSDK_EDGE_RISING,		//Trigger edge
		100,					//Internal Trigger source frequency
	};
	NoParameter sCh2CWMode = {FGSDK_CW_MODE_CH2};
	NoParameter sSendPtn = {FGSDK_SENDPTN};

	int iDevice = 0;
	puDsoSDKSetting(iDevice, DSS_FGCONTROL, &sCh1Data); //Set Ch1 carrier parameters
	puDsoSDKSetting(iDevice, DSS_FGCONTROL, &sCh2Data); //Set Ch2 carrier parameters
	puDsoSDKSetting(iDevice, DSS_FGCONTROL, &sCh1ModulData); //Set Ch1 to Modulation mode
	puDsoSDKSetting(iDevice, DSS_FGCONTROL, &sCh2CWMode);//Set Ch2 to Continuous wave mode
	puDsoSDKSetting(iDevice, DSS_FGCONTROL, &sTrigParameter);//Set Trigger data
	puDsoSDKSetting(iDevice, DSS_FGCONTROL, &sSendPtn);		//Send FG pattern
#endif
//FG SDK Block End
}

void CVcDsoDlg::OnCapture() 
{	
	SetFGPara();
	SetAllPara();
	puDsoSDKSetWaitMode(WAIT_FOREVER, 0);	// Single Shot must wait trigger forever.
	if( gpdFFTData )
	{
		delete [] gpdFFTData;
		gpdFFTData = NULL;
	}

	if( !puDsoSDKCaptureEx() )
	{
		int i =  puDsoSDKGetErrorCodeEx();
		char szMsg[256];
		GetErrStr( puDsoSDKGetErrorCodeEx(), szMsg, sizeof(szMsg) );
		MessageBox( szMsg );
	}
	else
	{
		m_fCaptured = true;
		GetDlgItem( IDC_CAPTURE )->EnableWindow( false );
		GetDlgItem( IDC_REPCAP )->EnableWindow( false );
		GetDlgItem( IDC_FFT )->EnableWindow( false );
		GetDlgItem( IDC_CB_DEPTH )->EnableWindow( false );
		if(m_fTS2212 || m_fTS2202)
		{
			if(m_iChkOnCH1 && m_iChkOnCH2)
			{
				CComboBox *pCtl;
				int	iSel;
				pCtl = (CComboBox *)GetDlgItem( IDC_CB_SAMPLERATE );
				iSel = pCtl->GetCurSel();
				if(iSel == 4) // 1 GHz
				{
					pCtl->SetCurSel(5); // 500 MHz
				}
			}
		}
		if( IsDlgButtonChecked( IDC_FFT ) == BST_CHECKED )
		{
			gpdFFTData = new double [m_iBufLen];
			ZeroMemory( gpdFFTData, m_iBufLen * sizeof(double) );
		}
		SetTimer( IDT_CAPTURE, 100, NULL );
	}	
}

void CVcDsoDlg::OnRepCap() 
{	
	SetFGPara();
	SetAllPara();
	GetDlgItem( IDC_FORCETRIG )->EnableWindow( false );
	puDsoSDKSetWaitMode(WAIT_SLOW, 0);	// Repeat mode: set wait trigger QUICK
	if( gpdFFTData )
	{
		delete [] gpdFFTData;
		gpdFFTData = NULL;
	}
	if( !puDsoSDKCaptureEx() )
	{
		char szMsg[256];
		GetErrStr( puDsoSDKGetErrorCodeEx(), szMsg, sizeof(szMsg) );
		MessageBox( szMsg );
	}
	else
	{
		m_fCaptured = true;
		m_InReCap = true;
		GetDlgItem( IDC_CAPTURE )->EnableWindow( false );
		GetDlgItem( IDC_REPCAP )->EnableWindow( false );
		GetDlgItem( IDC_FFT )->EnableWindow( false );
		GetDlgItem( IDC_CB_DEPTH )->EnableWindow( false );

		if(m_fTS2212 || m_fTS2202)
		{
			if(m_iChkOnCH1 && m_iChkOnCH2)
			{
				CComboBox *pCtl;
				int	iSel;
				pCtl = (CComboBox *)GetDlgItem( IDC_CB_SAMPLERATE );
				iSel = pCtl->GetCurSel();
				if(iSel == 4) // 1 GHz
				{
					pCtl->SetCurSel(5); // 500 MHz
				}
			}
		}
		if( IsDlgButtonChecked( IDC_FFT ) == BST_CHECKED )
		{
			gpdFFTData = new double [m_iBufLen];
			ZeroMemory( gpdFFTData, m_iBufLen * sizeof(double) );
		}
		SetTimer( IDT_REPCAP, 100, NULL );
	}	
}

void CVcDsoDlg::OnTimer(UINT nIDEvent) 
{
	CString		str;		
	CRect		rcRect;

	if(  nIDEvent == IDT_CAPTURE && (puDsoSDKDataReady()  || m_ForceTrig ))
	{
		KillTimer( IDT_CAPTURE );

		for (int iDev = 0; iDev < m_iDevCnt; iDev ++)
		{
			int iFlag = 0;
			gfDataReady = puDsoSDKReadExRaw( iDev, &iFlag, (m_pWaveData + (iDev * 2 * m_iBufLen)), 
												m_dOfsA + iDev * 2, m_dOfsB + iDev * 2, m_dMul + iDev * 2, NULL);  // Get Dso data
			//If iFlag & DSDF_TIMEOUT, means the trigger signal didn't happen during trigger wait time//
			if( IsDlgButtonChecked( IDC_FFT ) == BST_CHECKED )
				NULL;
		}
		
		if( gfDataReady )
		{
			if(CUR_TYPE	== DDEX_RAW)
				GetDlgItem(IDC_FFT)->EnableWindow(FALSE);
			else
				GetDlgItem(IDC_FFT)->EnableWindow(TRUE);
			RedrawWindow();
		}
		else
		{
			char szMsg[256];
			GetErrStr( puDsoSDKGetErrorCodeEx(), szMsg, sizeof(szMsg) );
			MessageBox( szMsg );
		}
		GetDlgItem( IDC_CAPTURE )->EnableWindow( true );
		GetDlgItem( IDC_REPCAP )->EnableWindow( true );
		GetDlgItem( IDC_CB_DEPTH )->EnableWindow( true );
		m_ForceTrig = false;
	}
	else if( nIDEvent == IDT_REPCAP )
	{
		if( puDsoSDKDataReady() )
		{
			for (int iDev = 0; iDev < m_iDevCnt; iDev ++)
			{
				int iFlag = 0;
				gfDataReady = puDsoSDKReadExRaw( iDev, &iFlag, (m_pWaveData + (iDev * 2 * m_iBufLen)), 
													m_dOfsA + iDev * 2, m_dOfsB + iDev * 2, m_dMul + iDev * 2, NULL);  // Get Dso data
				//If iFlag & DSDF_TIMEOUT, means the trigger signal didn't happen during trigger wait time//
				if( IsDlgButtonChecked( IDC_FFT ) == BST_CHECKED )
					NULL;
			}
			
			if( gfDataReady )
			{
				this->GetDlgItem(IDC_ST_PIC)->GetClientRect(rcRect);
				this->GetDlgItem(IDC_ST_PIC)->MapWindowPoints(this, rcRect);
				
				InvalidateRect( rcRect, true );
				UpdateWindow();
				SetAllPara();
				puDsoSDKSetWaitMode(WAIT_QUICK, 0); // Repeat mode: set wait trigger QUICK
				puDsoSDKCaptureEx();
			}
			else
			{
				KillTimer( IDT_REPCAP );
				char szMsg[256];
				GetErrStr( puDsoSDKGetErrorCodeEx(), szMsg, sizeof(szMsg) );
				MessageBox( szMsg );
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CVcDsoDlg::OnStop() 
{	
	KillTimer( IDT_CAPTURE );
	KillTimer( IDT_REPCAP );
	puDsoSDKStop();
	GetDlgItem( IDC_CAPTURE )->EnableWindow( true );
	GetDlgItem( IDC_REPCAP )->EnableWindow( true );
	if(CUR_TYPE	== DDEX_RAW)
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);
	else
		GetDlgItem(IDC_FFT)->EnableWindow(TRUE);
	GetDlgItem( IDC_CB_DEPTH )->EnableWindow( true );
	GetDlgItem( IDC_FORCETRIG )->EnableWindow( true );
	m_InReCap = false;
}

void CVcDsoDlg::OnSelchangeCbVd() 
{	
	RedrawWindow();
}

void CVcDsoDlg::OnChkProbeCh1() 
{	
	int			i, iMul, iSel;
	CString		str;
	CComboBox	*pctl;

	if( IsDlgButtonChecked( IDC_CHK_CH1X10 ) )
		iMul = 10; // x10
	else
		iMul = 1;  // x1
	pctl = (CComboBox *)GetDlgItem( IDC_CB_VDCH1 );
	iSel = pctl->GetCurSel();
	pctl->ResetContent();
	for( i = 0 ; i < sizeof(giVoltTable) / sizeof(giVoltTable[0]) ; i++ )
	{
		str.Format( "%d", giVoltTable[i] * iMul );
		pctl->AddString( str );
	}
	pctl->SetCurSel( iSel );	
}

void CVcDsoDlg::OnChkProbeCh2() 
{	
	int			i, iMul, iSel;
	CString		str;
	CComboBox	*pctl;

	if( IsDlgButtonChecked( IDC_CHK_CH2X10 ) )
		iMul = 10; // x10 
	else
		iMul = 1;  // x10 
	pctl = (CComboBox *)GetDlgItem( IDC_CB_VDCH2 );
	iSel = pctl->GetCurSel();
	pctl->ResetContent();
	for( i = 0 ; i < sizeof(giVoltTable) / sizeof(giVoltTable[0]) ; i++ )
	{
		str.Format( "%d", giVoltTable[i] * iMul );
		pctl->AddString( str );
	}
	pctl->SetCurSel( iSel );
}

void CVcDsoDlg::OnChkProbeCh3() 	
{	
	int			i, iMul, iSel;
	CString		str;
	CComboBox	*pctl;

	if( IsDlgButtonChecked( IDC_CHK_CH3X10 ) )
		iMul = 10; // x10
	else
		iMul = 1;  // x1
	pctl = (CComboBox *)GetDlgItem( IDC_CB_VDCH3 );
	iSel = pctl->GetCurSel();
	pctl->ResetContent();
	for( i = 0 ; i < sizeof(giVoltTable) / sizeof(giVoltTable[0]) ; i++ )
	{
		str.Format( "%d", giVoltTable[i] * iMul );
		pctl->AddString( str );
	}
	pctl->SetCurSel( iSel );	
}

void CVcDsoDlg::OnChkProbeCh4() 	
{	
	int			i, iMul, iSel;
	CString		str;
	CComboBox	*pctl;

	if( IsDlgButtonChecked( IDC_CHK_CH4X10 ) )
		iMul = 10; // x10
	else
		iMul = 1;  // x1
	pctl = (CComboBox *)GetDlgItem( IDC_CB_VDCH4 );
	iSel = pctl->GetCurSel();
	pctl->ResetContent();
	for( i = 0 ; i < sizeof(giVoltTable) / sizeof(giVoltTable[0]) ; i++ )
	{
		str.Format( "%d", giVoltTable[i] * iMul );
		pctl->AddString( str );
	}
	pctl->SetCurSel( iSel );	
}

void CVcDsoDlg::OnChkProbeCh5() 		
{	
	int			i, iMul, iSel;
	CString		str;
	CComboBox	*pctl;

	if( IsDlgButtonChecked( IDC_CHK_CH5X10 ) )
		iMul = 10; // x10
	else
		iMul = 1;  // x1
	pctl = (CComboBox *)GetDlgItem( IDC_CB_VDCH5 );
	iSel = pctl->GetCurSel();
	pctl->ResetContent();
	for( i = 0 ; i < sizeof(giVoltTable) / sizeof(giVoltTable[0]) ; i++ )
	{
		str.Format( "%d", giVoltTable[i] * iMul );
		pctl->AddString( str );
	}
	pctl->SetCurSel( iSel );	
}

void CVcDsoDlg::OnChkProbeCh6() 		
{	
	int			i, iMul, iSel;
	CString		str;
	CComboBox	*pctl;

	if( IsDlgButtonChecked( IDC_CHK_CH6X10 ) )
		iMul = 10; // x10
	else
		iMul = 1;  // x1
	pctl = (CComboBox *)GetDlgItem( IDC_CB_VDCH6 );
	iSel = pctl->GetCurSel();
	pctl->ResetContent();
	for( i = 0 ; i < sizeof(giVoltTable) / sizeof(giVoltTable[0]) ; i++ )
	{
		str.Format( "%d", giVoltTable[i] * iMul );
		pctl->AddString( str );
	}
	pctl->SetCurSel( iSel );	
}

void CVcDsoDlg::OnSelchangeCbSamplerate() 
{	
	CString			strSampleRate;
	int				iSel;
	
	GetDlgItemText( IDC_CB_SAMPLERATE, strSampleRate );
	pCtlMemDepth = (CComboBox *)GetDlgItem( IDC_CB_DEPTH );

	if( !m_fTS2202 && !m_fTS2212 )
	{   // Only DS1K used 
		if( strSampleRate.Compare( "2500000000" ) == 0 || strSampleRate.Compare( "5000000000" ) == 0 ) // 2.5G & 5G, Capture mode: Equivalent
		{
			pCtlMemDepth->ResetContent();
			pCtlMemDepth->AddString( "500" );
			pCtlMemDepth->AddString( "1000" );
			pCtlMemDepth->AddString( "2000" );
			pCtlMemDepth->AddString( "4000" );
			pCtlMemDepth->AddString( "8000" );
			pCtlMemDepth->AddString( "16000" );
			pCtlMemDepth->AddString( "25000" ); // Max. memory depth 25K on Equivalent mode
			pCtlMemDepth->SetCurSel( 2 );
		}
		else
		{
			iSel = pCtlMemDepth->GetCurSel();
			SetMemDepthItem();
			pCtlMemDepth->SetCurSel( iSel );
		}
	}
	else
	{
		iSel = pCtlMemDepth->GetCurSel();
		SetMemDepthItem();
		pCtlMemDepth->SetCurSel( iSel );
	}
	if( m_InReCap )
		OnRepCap();
}

void CVcDsoDlg::OnForceTrig() 
{	
	if( puDsoSDKForceTrig() )
	{
		m_ForceTrig = true; // trigger
		//GetDlgItem( IDC_CAPTURE )->EnableWindow( true );
		//GetDlgItem( IDC_REPCAP )->EnableWindow( true );	
	}
}

void CVcDsoDlg::OnSelchangeCbDepth() 
{	
}

void CVcDsoDlg::OnChOnOff() 
{	
	SetSRItem();
}
void CVcDsoDlg::OnBnClickedHwinfo()
{	
	char szBuf[64];
	char szDisplay[512];
	int iBufIdx = 0;
	const char* szInfoName[]=
	{
		"Manufacture: %s\n",
		"Product Name: %s\n",
		"Serial Number: %s\n",
		"HW Version: %d\n",
		"FW Version: %d\n",
		"Product ID: %X\n",
		"USB Handle: %d\n",
		0
	};
	for (int iDevice = 0; iDevice < m_iDevCnt && iDevice < CUR_DEMO_DEVICE; iDevice ++)
	{
		for (int i = 0; i < 7; i ++)
		{
			puDsoSDKGetHwInfo(iDevice, i, (LPVOID)szBuf);
			if (i < 3)
				iBufIdx += sprintf(szDisplay + iBufIdx, szInfoName[i], szBuf);
			else
				iBufIdx += sprintf(szDisplay + iBufIdx, szInfoName[i], *(int*)szBuf);
		}
	}
	AfxMessageBox(szDisplay);
}

void CVcDsoDlg::OnBnClickedGetstatus()
{
	int iStatus;
	int iBufIdx = 0;
	char szDisplay[512];
	
	for (int iDevice = 0; iDevice < m_iDevCnt; iDevice ++)
	{
		iStatus = puDsoSDKGetStatus(iDevice);		
		iBufIdx += sprintf(szDisplay + iBufIdx, "Device %d Status (%d)\n", iDevice, iStatus);		
	}
	AfxMessageBox(szDisplay);
}


void CVcDsoDlg::OnBnClickedGetmeasure()
{	
	int iBufIndex = 0;
	bool bForceStopFlag = false;
	char szText[256];
	bool fMeasResult[5] = {false};
	double dbValue[5];
	int piMeasureType[5] = 
	{
		MEASURE_FREQ,
		MEASURE_VMAX,
		MEASURE_VPP,
		MEASURE_RMS, 
		MEASURE_END
	};
	char * szMeasureName[]=
	{
		"Frequency = %.2lfHz\n",
		"Vmax = %.2lfV\n",
		"Vpp = %.2lfV\n",
		"Vrms = %.2lfV\n",
	};
	I64 i64SampleClock = 0;
	int iRecordLength = 0;
	puDsoSDKGetSampleRate(i64SampleClock);
	puDsoSDKGetRecordLength(iRecordLength);
	DSMEAS DsMeas;	
	memset(&DsMeas, 0, sizeof(DsMeas));
	DsMeas.lpwWaveData[0] = (WORD*)m_pCH1;
	DsMeas.dYOfsA[0] = m_dOfsA[0];
	DsMeas.dYOfsB[0] = m_dOfsB[0];
	DsMeas.dYMul[0] = m_dMul[0];
	DsMeas.iRecordLength = iRecordLength;
	DsMeas.i64ScData = i64SampleClock;
	if (IsDlgButtonChecked( IDC_CHK_CH1X10 ))
		DsMeas.iProbe[0] = 10;
	else
		DsMeas.iProbe[0] = 1;
	if (IsDlgButtonChecked( IDC_CHK_CH2X10 ))
		DsMeas.iProbe[1] = 10;
	else
		DsMeas.iProbe[1] = 1;
	if (puDsoSDKMeasurement(piMeasureType, 0, (int)iRecordLength - 1, &DsMeas, &bForceStopFlag, fMeasResult, dbValue))
	{	
		for (int i = 0; piMeasureType[i] != MEASURE_END; i ++)
		{
			if (fMeasResult[i])
				iBufIndex += sprintf_s(szText + iBufIndex, sizeof(szText) - iBufIndex, szMeasureName[i], dbValue[i]);		
			else
				iBufIndex += sprintf_s(szText + iBufIndex, sizeof(szText) - iBufIndex, "Calculate Fail\n");		
		}
		AfxMessageBox(szText);		
	}
}


void CVcDsoDlg::OnBnClickedBnReadini()
{
	// TODO: Add your control notification handler code here
	PUDSOSDKREADINIFILE puDsoSDKReadIniFile;
	puDsoSDKReadIniFile = (PUDSOSDKREADINIFILE)GetProcAddress(ghmDso, "uDsoSDKReadIniFile");
	if (!puDsoSDKReadIniFile("Dso.ini"))
		AfxMessageBox("Ini Read Error");
}
