// VcDsoDlg.h : header file
//

#if !defined(AFX_VCDSODLG_H__A69D2964_8C98_4E15_A63C_347CE6FC6BF6__INCLUDED_)
#define AFX_VCDSODLG_H__A69D2964_8C98_4E15_A63C_347CE6FC6BF6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DsoSDKDef.h"
#include "FGSDK_Symbol.h"

#define CUR_DEMO_DEVICE 3

/////////////////////////////////////////////////////////////////////////////
// CVcDsoDlg dialog

#if ( CUR_TYPE == DDEX_RAW )
	#define		AQTYPE		short
	#define VFUNC( data, mul, ofsa, ofsb )		( (int)( ( (double)(data) - ofsa ) * mul + ofsb ) )
	#define FFT_MUL		2000

#elif( CUR_TYPE == DDEX_DBL_MV || CUR_TYPE == DDEX_DBL_UV )
	#define		AQTYPE		double
	#if ( CUR_TYPE == DDEX_DBL_MV )
		#define VFUNC( data, mul, ofsa, ofsb )		( data )
		#define FFT_MUL		2000
	#elif ( CUR_TYPE == DDEX_DBL_UV )
		#define VFUNC( data, mul, ofsa, ofsb )		( (data) / 1000 )
		#define FFT_MUL		2000000
	#endif

#else
	#define		AQTYPE		int
	#if ( CUR_TYPE == DDEX_INT_MV )
		#define VFUNC( data, mul, ofsa, ofsb )		( data )
		#define FFT_MUL		2000
	#elif ( CUR_TYPE == DDEX_INT_UV )
		#define VFUNC( data, mul, ofsa, ofsb )		( (data) / 1000 )
		#define FFT_MUL		2000000
	#endif

#endif

class CVcDsoDlg : public CDialog
{
// Construction
public:
	CVcDsoDlg(CWnd* pParent = NULL);	// standard constructor
	void SetAllPara();
	void SetMemDepthItem();
	void SetSRItem();
	void SetFGPara();
	void Freq2Str( __int64 i64Freq, CString &str );
	void GetErrStr( int iErrCode, LPSTR lpszErrMsg, int iSize );

	AQTYPE		*m_pWaveData;					// Waveform buffer.
	AQTYPE		*m_pCH1, *m_pCH2, *m_pCH3, *m_pCH4, *m_pCH5, *m_pCH6;

	BOOL		m_fCaptured;
	BOOL		m_fDS1302;
	BOOL		m_fDS1202;
	BOOL		m_fDS1102;
	BOOL		m_fDS1002;
	BOOL		m_fTS2202;
	BOOL		m_fTS2212;
	BOOL		m_fEquv;
	int			m_iDevCnt;
	int			m_iBufLen;
	int			m_iChkOnCH1, m_iChkOnCH2, m_iChkOnCH3, m_iChkOnCH4, m_iChkOnCH5, m_iChkOnCH6;
	BOOL		m_ForceTrig;
	BOOL		m_InReCap;
	double		m_dMul[2*CUR_DEMO_DEVICE], m_dOfsA[2*CUR_DEMO_DEVICE], m_dOfsB[2*CUR_DEMO_DEVICE];


// Dialog Data
	//{{AFX_DATA(CVcDsoDlg)
	enum { IDD = IDD_VCDSO_DIALOG };
	CButton	m_bnOnCH2;
	CButton	m_bnOnCH1;
	CButton	m_bnOnCH3;
	CButton	m_bnOnCH4;
	CButton	m_bnOnCH5;
	CButton	m_bnOnCH6;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVcDsoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON			m_hIcon;
	CComboBox		*pCtlMemDepth;
	// Generated message map functions
	//{{AFX_MSG(CVcDsoDlg)
	void SampleUIInitial();
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGetHW();
	afx_msg void OnSetStack();	//20130521
	afx_msg void OnCapture();
	afx_msg void OnRepCap();
	afx_msg void OnStop();
	afx_msg void OnSelchangeCbVd();
	afx_msg void OnChkProbeCh1();
	afx_msg void OnChkProbeCh2();
	afx_msg void OnChkProbeCh3();
	afx_msg void OnChkProbeCh4();
	afx_msg void OnChkProbeCh5();
	afx_msg void OnChkProbeCh6();
	afx_msg void OnSelchangeCbSamplerate();
	afx_msg void OnForceTrig();
	afx_msg void OnSelchangeCbDepth();
	afx_msg void OnChOnOff();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedTest();
	afx_msg void OnBnClickedHwinfo();
	afx_msg void OnBnClickedGetstatus();
	afx_msg void OnBnClickedGetmeasure();
	afx_msg void OnBnClickedBnReadini();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VCDSODLG_H__A69D2964_8C98_4E15_A63C_347CE6FC6BF6__INCLUDED_)
